$Id: README,v 1.7 2003/12/18 21:25:49 pletzer Exp $

GACO
====

Title:

GACO=GAbor COllocation: Solve ODEs and PDEs by expanding the solution in Gabor wave packets.

Keywords:

Gabor wave packets, collocation, differential equation.

Language:

Fortran90 and C


1. Abstract
2. Building instructions
3. Test suite
4. Code organization
5. Documentation
6. Anatomy of a driver
7. Assembly step
8. Loose ends
9. References

1. Abstract
-----------

GACO=GAbor COllocation, is a package written in Fortran95 to solve ODEs and PDEs based on expanding the solution in Gabor wave packets. 

Gaco uses the collocation method, the test functions upon which the equation is projected onto are Dirac delta functions. This makes numerical integration trivial, it also eliminates inaccuracies associated with numerical quadrature. 

A Gabor wave packet is a sinusoidal exp(i *k*x) wave with a Gaussian envelope exp(-sigma*(x-z)^2/2):

g(k,z; x) = exp(I *k*x) * exp(-sigma*(x-z)^2/2) (I is the imaginary sqrt(-1) number)

The expansion takes place both in frequency space, k = j*delta_k with j=-Nj..+Nj (like FFT) and in configuration (real) space. The expansion in configuration space comes from shifting the envelope position, z = i*delta_x i=0..Nz, (similar to the finite element method) across the domain. The Gabor wave packet expansion differs, however, from FFT in that the solution need not satisfy periodic boundary conditions. The Gabor wave packets also have the advantage to be smooth to all order (contrary to finite elements). Therefore, GACO can be used to solve ODEs/PDEs of, in principle, arbitrary order (a limit of 10 presently applies).

The main drawback of using Gabors is that the stiffness matrix is less sparse than that obtained using finite elements. (Formally the stiffness matrix is full, however, finite machine accuracy renders the matrix sparse.) The sparsity pattern depends the overlap between Gabors. Because the Gabors decay faster than exponentially away from z, overlapping contributions can often be neglected. For example, the overlap of two Gabors that are 6-7 times 1/sqrt(sigma) distance away only contribute to < 1e-10.

The main advantage of GACO over finite elements is that fewer degrees of freedom are in general required to capture the solution. This is particularly true when the solution has small scale oscillations.

The critical parameters in the Gabor expansion are:

delta_k (grid resolution in k-space)
delta_x (grid resolution in x-space)
sigma   (inverse sqrt(width) of the Gaussian envelopes)

The parameter delta_x is given by the number of Gabor envelopes (Nz+1). Frame theory [1] requires that delta_k * delta_x < 2*pi in order to be able to reconstruct the solution. It is convenient to define the sampling parameter

delta_k * delta_x  = 2*pi/sampling 

Stable reconstruction means sampling > 1. Note that this relation does not depend on sigma. Typically sigma is chosen to be ~1 /delta_x^2. In the limit of sigma -> 0 one recovers FFT. In the limit where sigma -> infinity the Gabors approach Dirac functions. 

A sampling value close to 1 allows to scan the biggest region in k-space and so extract small features most economically. However, larger sampling values confer more stability and robustness to GACO. 


2. Building instructions
------------------------

You need a C and Fortran95 compiler as well as Gnu make (gmake). The code has been developed on a Linux Box but should be portable across UNIX. It compiles with lf95 6.1 (Lahey-Fujitsu) and ifc 7.1 (Intel). 

The following packages are prerequisites:

NetCDF: http://www.unidata.ucar.edu/packages/netcdf/
EZcdf: http://w3.pppl.gov/rib/repositories/NTCC/catalog/Asset/EZcdf.html (used to save/load derived types to and from disk)
SuperLU: http://crd.lbl.gov/~xiaoye/SuperLU/ (used to solve sparse matrix problems)
GSL: http://sources.redhat.com/gsl/ (only required for a test problem)
Python: http://python.org (doc generator)

Optionally (for graphics only):

Plotmtv: http://aixpdslib.seas.ucla.edu/packages/plotmtv.html

To build GACO, the user must provide the location of the above packages as well as the name of the compiler, and so forth, while invoking gmake. This could be either done by editing the Makefile, or by passing arguments to gmake.

To build Gaco with ifc, which produces the fastest code, I type

gmake F90=/usr/local/intel-7.1/compiler70/ia32/bin/ifc NTCC=/usr/ntcc/ifc GSL=/usr/local/gsl-1.4 SUPERLU=/usr/local/superlu CLIB=-lPEPCF90

(You may need to set your LD_LIBRARY_PATH variable: setenv LD_LIBRARY_PATH /usr/local/gsl-1.4/lib)


To build Gaco with the Lahey-Fujitsu compiler, with all debugging switches turned on, I type

gmake F90=/usr/local/lff95/bin/lf95 FOPT="-g --chk a,e,u,s --trace --trap" NTCC=/usr/ntcc/lff95 GSL=/usr/local/gsl-1.4 SUPERLU=/usr/local/superlu

(You may need to set your LD_LIBRARY_PATH variable: setenv LD_LIBRARY_PATH /usr/local/lff95/lib:/usr/local/gsl-1.4/lib)

To clean up the directory, type

gmake reaclean

(will delete *.o *.mod and the executables), or 

gmake clean 

in order to delete only the *.o files.

Here, NTCC refers to the location of the EZcdf library (${NTCC}/lib), setting CLIB is required in order resolve the system library call.

3. Test suite
-------------

Gaco comes with two programs, tester and driver. The first program tortures various modules  while the second solves ODE problems. To get quickly started you may want to take a look at driver.f90.


4. Code organization
--------------------

Gaco is a collection of modules that combine to solve ODEs and PDEs with arbitrary number of components (unknowns) and in arbitrary dimensional space. A module contains a derived type (similar to a struct in C) and subroutines that act on this type (similar to methods in C++). A module is roughly equivalent to a class in object oriented languages. 

For module XYZ, the derived type is typically called XYZ_obj. The first argument in the method call must be an instance of type XYZ_obj. A module XYZ has a constructor (XYZ_init) to allocate and initialize the object XYZ_obj, and a destructor (XYZ_free) to reclaim the allocated memory.

Note that each call to XYZ_init should accompagnied by a call to XYZ_free, or your program will leak memory.

Modules also have a XYZ_test method, which illustrates a typical use of the module (in addition to testing it).

Some modules allow the object to be saved on disk via XYZ_save and retrieved from disk via a XYZ_load call. The parameters are set via 'XYZ_set...' calls and the result of calculations are typically extracted via 'XYZ_get...' calls.

Examples of modules:

indexer (indexer.f90):  Maps a multi-index expansion into an expansion using a single index. 
 
kzgrid (xkzgrid.f90): Given a single index, compute the wave-vector k and the Gabor position.

xgrid (xgrid.f90): Given a single index, compute the collocation position.

operators (operators.f90): Define a set of operators to solve ODEs/PDEs.

gabor (gabor.f90): Computes the Gabor functions in 1 and N-dimensions.

sparseC16 (supralu_mod.f90): Sparse matrix representation.

plotmtv (plotmtv.f90): Some basic plotting utilities. 


5. Documentation
----------------

All modules, routines and types are documented in doc.txt.

A "live" documentation system is available. 

To generate the complete documentation, type

doc --all 

To show the file structure (modules, subroutines, etc), type:

doc --file <file.f90> 

To show the module structure (type member, subroutine methods), type:

doc --module <module_name> <file.f90>

To show a routine (function or subroutine) calling syntax, type:

doc --routine <routine_name> <file.f90>


6. Anatomy of a driver
----------------------

The user is encouraged to take a look into one of the example driver programs, for instance airy.f90 which contains:

MODULE  airy
        TYPE  airy_obj
                SUBROUTINE airy_init(this, Nz, Nj, sigma_dx2, sampling)

                SUBROUTINE airy_free(this)

                SUBROUTINE airy_set_domain(this, xmin, xmax)

                SUBROUTINE airy_set_tol(this, tol)

                SUBROUTINE airy_set_equation(this, alpha)

                SUBROUTINE airy_set_bcs(this, bc0, bc1)

                SUBROUTINE airy_assemble(this)

                SUBROUTINE airy_solve(this)

                SUBROUTINE airy_get_solution(this, x, y)

                SUBROUTINE airy_plot(this, x, y)

                SUBROUTINE airy_test(this)

The derived type captures all the parameters needed to solve the problem. 

  type airy_obj
     integer :: Nz ! No of Gabor intervals
     integer :: Nj ! Fourier modes -Nj .. + Nj
     real(r8) :: sampling  ! sampling rate > 1
     real(r8) :: alpha ! equation parameter
     real(r8) :: tol ! sparsity tolerance
     complex(r8) :: bc0, bc1 ! Boundary conditions
     real(r8) :: xmin, xmax ! domain boundary

     real(r8) :: eps
     real(r8) :: sigma
     integer :: Nx
     type(sparseC16_obj) :: amat
     type(indexer_obj) :: iter2
     type(kzgrid_obj) :: kzg
     complex(r8), dimension(:), pointer :: xvec, bvec

  end type airy_obj

The first group of parameters (Nz -> xmax) define the discretization, geometry, and equation parameters (which vary from problem to problem).  The data members of type airy_obj are populated via

type(airy_obj) :: this
...

SUBROUTINE airy_init(this, Nz, Nj, sigma_dx2, sampling)

and, optionally, via "setters"

SUBROUTINE airy_set_domain(this, xmin, xmax)
SUBROUTINE airy_set_tol(this, tol)
SUBROUTINE airy_set_equation(this, alpha)
SUBROUTINE airy_set_bcs(this, bc0, bc1)


The airy_init method will set reasonable default parameters. Note the parameter "tol", which sets the sparsity tolerance. That is, a matrix element whose absolute value is < tol will not be filled in. Typically, "tol" should be comparable to the overall numerical accuracy that is desired. A larger "tol" will yield sparser matrices and so be more efficient. 

The crucial method is 

SUBROUTINE airy_assemble(this)

which assembles the sparse matrix system. We'll come back to it later. The method

SUBROUTINE airy_solve(this)

should be called after airy_assemble; it solves the matrix system. The result is a vector of (complex) amplitudes. In order to get the solution "y" on an arbitrary set of points "x", you can call 

SUBROUTINE airy_get_solution(this, x, y)

The vector can be plotted using 

SUBROUTINE airy_plot(this, x, y)

When you are finished, just call

SUBROUTINE airy_free(this)

A complete test driver is available in 

SUBROUTINE airy_test(this)


7. Assembly step
----------------

Let's dive into SUBROUTINE airy_assemble. In general a problem will have "Nd" dimensions (e.g. Nd=3 in 3D) and "Nc" components (e.g. Nc=2 for two coupled equations). Unless otherwise specified, we will not assume a fixed "Nd" or "Nc". In "Nd" dimensions, the collocation positions, the Gabor k-vector and the Gabor envelope positions "z" will be vectors of size "Nd". Hence, the expansion of the solution will involve Nd (for k) + Nd (for z) + 1 (vector component) = 2*Nd+1 indices. The sparse matrix on the other hand will require all these indices to collapse to a single global index. The mapping between the 2*Nd+1 indices and the single matrix index is taken care by the "indexer" module.  

Let us be more specific and assume that the same number of Fourier modes holds across the domain. Let the k-wavevector indices be the vector j(1:Nd), the z-position indices be the vector i(1:Nd) and the component index be k. The (Fourier) j indices range from -Nj..+Nj where Nj is an integer vector of size Nd, which is constant across the domain. Likewise, i indices range from 0..Nz where Nz is a vector of size Nd denoting the number of Gabor envelopes in each dimension. (There will be different Nj's and Nz's for each dimension.) In a convential approach, the matrix assmebly would involve looping over each of the 2*Nd+1 indices (leading to 2*Nd+1 nested do-loops). Fortunately, there is a better approach. The user "constructs" an indexer instance using two vectors "sizes" and "starts" that determine the range of the indices. The memeory layout will be determined by th eorder in which these values are fed to "sizes" and "starts" (which should be mutually consistent). For example, if Nd=2 (x, y) and Nc=3 (Ex, Ey, Ez), a possible layout would be

type(indexer_obj) :: iter2 ! somewhere at the top of the unit
integer :: ier ! error flag (/=0 if problem)
...
! set the memory layout
sizes = (/ Nc, 2*Nj(1)+1, 2*Nj(2)+1, Nz(1)+1, Nz(2)+1 /)
starts =(/ 1,   -Nj(1)  ,  -Nj(2)  ,       0,       0 /)

call indexer_init(iter2, sizes, starts, ier)

which would indicate that indices vary fastest in components (Nc components starting at 1), then Fourier mode in x [2*Nj(1)+1 modes starting at -Nj(1)], Fourier mode in y [2*Nj(2)+1 modes starting at -Nj(2)], Gabor position in x [Nx(1)+1 values], and Gabor position in y [Nx(2)+1 values]. Here, "iter2" is the indexer object, a compound type that will take care of updating each index as we loop through the global index to assemble the matrix system. The advantage of using the "iter2" object over hand-coded, do loops are (1) only one level of do-loop is required as opposed to 2*Nd+1 nested do-loops and (2) the way the array of unknown is flattened can be modified simply by changing "sizes" and "starts". In particular, this will allow the user to experiment which layout is numerically more favorable, yielding a more diagonally dominant matrix and ultimately a faster solution for instance, with minimal fuss. Should the user desire to pack the envelope positions together, then the Fourier modes and finally the components, this would be achieved by setting

sizes = (/  Nz(1)+1, Nz(2)+1, 2*Nj(1)+1, 2*Nj(2)+1, Nc /)
starts =(/        0,       0,  -Nj(1)  ,  -Nj(2)  ,  1 /)


Similarly, another indexer object is required to map the collocation positions into a global matrix index. Depending on your preferences, you could choose:

type(indexer_obj) :: iter1 ! somewhere at the top of the unit
...
sizes = (/ Nc, Nx(1)+1, Nx(2)+1 /)
starts =(/ 1, 0, 0 /)
call indexer_init(iter1, sizes, starts, ier)
...


Indices are updated using the indexer_next method:


do i2 = iter2 % ntot
	call indexer_next(iter2, ier) ! update second set of indices
	...
	do i1 = iter1 % ntot
		call indexer_next(iter1, ier) ! update first set of indices
		...

where the data member ntot is just the product of the elements of "sizes". Note that the collocation iteration is inside the Gabor expansion iteration because the matrix elements, as we will see, need to be filled by running down the columns (column compress storage).

We've sen how the intricate nesting of do-loops contracts to two (i1 and i2) single do-loops regardless of "Nd" and "Nc" through the use of the indexer objects. We still need to access each index inside a do-loop in order to determine the k-wavevector, z-position and component inside the i2 iteration, as well as the component and collocation position x inside the i1 iteration. Assuming the grid to be uniform, we can do this by constructing an kzgrid object to map the indices into (k-wavevector, z-position), and a xgrid object to map the indices into x-position, respectively:

type(xgrid_obj)  :: xg
type(kzgrid_obj) :: kzg
integer :: x_map(Nd), kz_map(2*Nd)
...

! maps iter2 indices to k and z indices, resp.
! here assume sizes=(/Nc, 2*Nj(:)+1, Nz(:)+1) /)
do i = 1, Nd
	kz_map(i   ) = i   +1
       	kz_map(i+Nd) = i+Nd+1
end do
call kzgrid_init(kzg, xmin, xmax, Nz, Nj, sampling, kz_map, ier)

! maps indices of iter1 to x-indices
! here assume sizes=(/Nc, Nx(:)+1) /)
do i = 1, Nd
	x_map(i) = i + 1
end do
call xgrid_init(xg, xmin, xmax, Nx, x_map, ier)

Inside the i1 do loop we can now access the k-wavevector (kwav) and z-position (zpos)

	call indexer_get(iter2, all_ind2, ier)
	! all_ind2 contains i(1:Nd) and j(1:Nd) in some order
	call kzgrid_get(this % kzg, all_ind2, kwav, zpos, ier) 

To access the collocation position (xpos) in the i1 iteration we do:

		call indexer_get(iter1, all_ind1, ier)
		! all_ind1 contains el(1:Nd) in some order
          	call xgrid_get(xg, all_ind1, xpos, ier)
	

Neglecting the issue of boundary conditions for the time being, we're now in a position to fill in the matrix elements. As pointed out earlier it is essential to fill these column by column after incrementing each row. Naturally, only non-zero elements need to be stored allowing us to skip some rows. The matrix elements will be stored in a complex*16 sparse matrix compound type 

type(sparseC16_obj) :: amat

which is initialized via

base = 0
call sparseC16_init(amat, rank, nnz, base, ier)

where "rank" is the matrix rank (an integer equal iter2 % ntot above), "nnz" the expected number of non-zero entries (or larger), and "base" should at present be set to zero. With Gaco it may be difficult to estimate "nnz". For small problems that fit in memory you may simply want to set nnz = rank**2. The matrix elements are filled with the value "val" by 

		call sparseC16_set_next(amat, i1-1, newcol_flag, val, ier)

where "i1" is the global row index (the -1 is required because base=0) and newcol_flag a logical variable that should be set to .TRUE. when the column index "i2" changed. 

The complex "val" represents the ODE (PDE) operator applied on a Gabor function with given kwav (k-wavevector), zpos (envelope position) and evaluated at the xpos (collocation position). Derivatives of Gabors can be computed 

gabor_fct = GaborN(xpos, zpos, kwav, sigma)
call derivative(order, xpos, kwav, zpos, sigma, val, ier)
val = val * gabor_fct

where 0 <= order <= 10. GaborN and derivative are defined in the gabor, respectively operators modules. Feel free to add your own operators in the latter.

Boundary conditions need to be applied "by hand" (there is no universal data structure to help) during the assembly step. While it is possible to massage the matrix system after filling in the elements, this is not recommended as this may upset the matrix sparsity patterns. Boundary conditions of the form y^(n)(xbound) = const where n denotes the order of the derivative and xbound is typically either xmin or xmax, are implemented by setting the elements of a row to the nth derivative the Gabor functions g^(n)(k,z; xbound). Formally speaking, any row would do. We should keep in mind, however, that the collocation node associated with the row is effectively be removed by this process.


8. Loose ends
-------------

While GACO has been written with flexibility in mind and most elements are in place to solve equations in higher than one dimensions, all tests conducted so far were in 1D only.

A uniform (x, z) mesh is assumed. However, the Gabor collocation method does not preclude the use of a non-uniform mesh per se. It may be desirable in specific situations to pack the z envelope positions in some regions. Likewise, there could be some benefits in using a variable number of Fourier modes (which would prevent the use of the indexer object), or sigma paramater. For instance, more Fourier modes could be used in regions where the solution is expected to exhibit fine structures. It is also possible to pack the collocation points. In this case new data structures would be required to replace xgrid (when the collocation points are packed) or kzgrid (when the z-positions are packed). 

9. References
-------------

[1] "Ten Lectures on Wavelets" by I. Daubechies. (Cbms-Nsf Regional Conference Series in Applied Mathematics, No 61, May 1992).
[2] Some error convergence tests for the Gabor collocation method are available at http://w3.pppl.gov/~pletzer/wavelets/collocation/convergence/readme.txt

module kzgrid

  ! Handles the conversion of indices returned by the indexer into 
  ! ak (=wavenumber) and z (=Gabor positons).

  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)
  real(r8), parameter, private :: twopi = 6.2831853071795865_r8
  character(*), parameter, private :: version = &
       & '$Id: xkzgrid.f90,v 1.5 2003/10/01 19:13:38 pletzer Exp $'

  type kzgrid_obj
     integer ndims
     integer, pointer :: L(:), J(:)
     real(r8), pointer :: xmin(:), xmax(:)
     real(r8), pointer :: delta_k(:), delta_z(:)
     real(r8), pointer :: sampling(:)
     integer, pointer :: map_kz_indices(:)
     
  end type kzgrid_obj

  contains 

    subroutine kzgrid_init(this, xmin, xmax, L, J, sampling, map_kz_indices, ier)
      
      ! Constructor

      implicit none
      type(kzgrid_obj) :: this
      ! min/max points in the domain
      real(r8), intent(in) :: xmin(:), xmax(:)      
      integer, intent(in) :: L(:) ! L+1 envelopes
      integer, intent(in) :: J(:) ! 2*J+1 Fourier modes
      real(r8), intent(in) :: sampling(:) ! sampling rate should be > 1

      ! map_kz_indices maps the set of indices returned by the indexer into
      ! the indices of k and z (in that order). This provides the flexibility
      ! the reorder the memory layout for best performance. 
      !
      ! Example: in 3D, a possible layout could be map_kz_indices = (/2,3,4, 5,6,7/),
      ! ie the 2nd, 3rd, and 4th indices give the k-vector while indices 5, 6, and 7 
      ! yield the Gabor positions. In this case index 1 would be associated
      ! with field components, for instance. If one rather prefers to iterate first over 
      ! the k-vector and then over field components, set map_kz_indices = (/1,2,3, 5,6,7/). 
      integer, intent(in) :: map_kz_indices(:)
      integer, intent(out) :: ier

      ier = 0
      this % ndims = size(xmin)
      allocate(this % xmin(this % ndims))
      allocate(this % xmax(this % ndims))
      allocate(this % delta_k(this % ndims))
      allocate(this % delta_z(this % ndims))
      allocate(this % L(this % ndims))
      allocate(this % J(this % ndims))
      allocate(this % sampling(this % ndims))
      allocate(this % map_kz_indices(2*this % ndims))

      this % xmin = xmin
      this % xmax = xmax
      this % sampling = sampling
      this % L = L
      this % J = J
      this % map_kz_indices = map_kz_indices
      
      this % delta_z = (xmax - xmin)/L
      this % delta_k = twopi/(this%delta_z * sampling)

    end subroutine kzgrid_init

    subroutine kzgrid_free(this, ier)

      ! Destructor

      implicit none
      type(kzgrid_obj) :: this
      integer, intent(out) :: ier

      ier = 0
      deallocate(this % xmin)
      deallocate(this % xmax)
      deallocate(this % delta_k)
      deallocate(this % delta_z)
      deallocate(this % L)
      deallocate(this % J)
      deallocate(this % sampling)
      deallocate(this % map_kz_indices)
      
    end subroutine kzgrid_free

    subroutine kzgrid_get(this, indices, ak, z, ier)

      ! Given a set of indices, return the components of 
      ! x, k, and z.

      implicit none
      type(kzgrid_obj) :: this
      integer, intent(in) :: indices(:) ! from indexer
      real(r8), intent(out) :: ak(:), z(:) ! Wavenumber and Gabor position
      integer, intent(out) :: ier

      integer j

      ier = 0
      do j = 1, this % ndims
         ak(j) = indices(this%map_kz_indices(j          )) * this%delta_k(j)
         z(j)  = this%xmin(j) +  &
              &  indices(this%map_kz_indices(j+this%ndims)) * this%delta_z(j)
      enddo
      
    end subroutine kzgrid_get

    subroutine kzgrid_test(this, ier)

      ! Tester

      implicit none
      type(kzgrid_obj) :: this
      integer, intent(out) :: ier

      integer, parameter :: ndims = 2 ! 2-d space
      integer, parameter, dimension(ndims) :: L = (/5, 8/) ! no of Gabor intervals
      integer, parameter, dimension(ndims) :: J = (/2, 1/) ! no of positive *and* negative Fourier modes
      ! computational domain
      real(r8), parameter, dimension(ndims) :: xmin = (/0._r8, -1._r8/)
      real(r8), parameter, dimension(ndims) :: xmax = (/1._r8, +1._r8/)
      real(r8), parameter, dimension(ndims) :: sampling = (/2.0_r8, 4.0_r8/) ! sampling rate > 1
      integer :: map_kz_indices(2*ndims), indices(2*ndims+1)
      real(r8) :: ak(ndims), z(ndims)

      ier = 0

      print *,'testing kzgrid ', trim(version)
      ! kx, ky correspond to indices 2 and 3
      ! zx, zy correspond to indices 4 and 5
      map_kz_indices = (/2,3, 4,5/)
      print *,'ndims=', ndims
      print *,'L=', L, ' J=',J
      print '(2(a,2f10.3))', 'xmin=', xmin, ' xmax=', xmax
      print '(a,2f10.3)','sampling rate=', sampling
      print *,'index mapping=', map_kz_indices 

      call kzgrid_init(this, xmin, xmax, L, J, sampling, map_kz_indices, ier)

      indices = (/1, -2, -1, 0, 8/)
      call kzgrid_get(this, indices, ak, z, ier)
      print *,'indices=', indices
      print '(2(a,2f10.3))',' ak=', ak, ' z=',z

      indices = (/2, +2, +1, 0, 8/)
      call kzgrid_get(this, indices, ak, z, ier)
      print *,'indices=', indices
      print '(2(a,2f10.3))',' ak=', ak, ' z=',z
      
      indices = (/2, 0, 0, 0, 8/)
      call kzgrid_get(this, indices, ak, z, ier)
      print *,'indices=', indices
      print '(2(a,2f10.3))',' ak=', ak, ' z=',z

      indices = (/2, 1, 0, 0, 8/)
      call kzgrid_get(this, indices, ak, z, ier)
      print *,'indices=', indices
      print '(2(a,2f10.3))',' ak=', ak, ' z=',z

      indices = (/2, 1, 0, 5, 0/)
      call kzgrid_get(this, indices, ak, z, ier)
      print *,'indices=', indices
      print '(2(a,2f10.3))',' ak=', ak, ' z=',z

      call kzgrid_free(this, ier)

    end subroutine kzgrid_test

end module kzgrid

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module xgrid

  ! Handles the conversion of indices returned by the indexer into 
  ! x (= collocation) positions.

  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)
  real(r8), parameter, private :: twopi = 6.2831853071795865_r8
  character(*), parameter, private :: version = &
       & '$Id: xkzgrid.f90,v 1.5 2003/10/01 19:13:38 pletzer Exp $'

  type xgrid_obj
     integer ndims
     integer, pointer :: M(:) ! no of intervals
     real(r8), pointer :: xmin(:), xmax(:)
     real(r8), pointer :: delta_x(:)
     integer, pointer :: map_x_indices(:)     
  end type xgrid_obj

  contains 

    subroutine xgrid_init(this, xmin, xmax, M, map_x_indices, ier)
      
      ! Constructor

      implicit none
      type(xgrid_obj) :: this
      ! min/max points in the domain
      real(r8), intent(in) :: xmin(:), xmax(:)      
      integer, intent(in) :: M(:) ! M+1 collocation points

      ! map_x_indices maps the set of indices returned by the indexer into
      ! the indices of collocation points. This provides the flexibility
      ! the reorder the memory layout for best performance. 
      !
      ! Example: in 3D, a possible layout could be map_x_indices = (/2,3,4/),
      ! ie the 2nd, 3rd and 4th indices give the x-point. In this case index 1  
      ! would be associated with field components, for instance. If one rather prefers 
      ! to iterate first over x-components and then over field components, set
      ! map_x_indices = (/1,2,3/). 
      integer, intent(in) :: map_x_indices(:)
      integer, intent(out) :: ier

      ier = 0
      this % ndims = size(xmin)
      allocate(this % xmin(this % ndims))
      allocate(this % xmax(this % ndims))
      allocate(this % delta_x(this % ndims))
      allocate(this % M(this % ndims))
      allocate(this % map_x_indices(this % ndims))

      this % xmin = xmin
      this % xmax = xmax
      this % M = M
      this % map_x_indices = map_x_indices
      
      this % delta_x = (this%xmax - this%xmin)/this%M

    end subroutine xgrid_init

    subroutine xgrid_free(this, ier)

      ! Destructor

      implicit none
      type(xgrid_obj) :: this
      integer, intent(out) :: ier

      ier = 0
      deallocate(this % xmin)
      deallocate(this % xmax)
      deallocate(this % delta_x)
      deallocate(this % M)
      deallocate(this % map_x_indices)
      
    end subroutine xgrid_free

    subroutine xgrid_get(this, indices, x, ier)

      ! Given a set of indices, return the components of 
      ! x.

      implicit none
      type(xgrid_obj) :: this
      integer, intent(in) :: indices(:) ! from indexer
      real(r8), intent(out) :: x(:)     ! collocation position
      integer, intent(out) :: ier

      integer j

      ier = 0
      do j = 1, this % ndims
         x(j)  = this%xmin(j) + &
              &  indices(this%map_x_indices(j)) * this%delta_x(j)
      enddo
      
    end subroutine xgrid_get

    subroutine xgrid_test(this, ier)

      ! Tester

      implicit none
      type(xgrid_obj) :: this
      integer, intent(out) :: ier

      integer, parameter :: ndims = 2 ! 2-d space
      integer, parameter, dimension(ndims) :: M = (/5, 8/) ! no of collocation intervals
      ! computational domain
      real(r8), parameter, dimension(ndims) :: xmin = (/0._r8, -1._r8/)
      real(r8), parameter, dimension(ndims) :: xmax = (/1._r8, +1._r8/)
      integer :: map_x_indices(ndims), indices(ndims+1)
      real(r8) :: x(ndims)

      ier = 0

      print *,'testing xgrid ', trim(version)
      map_x_indices = (/2,3/)
      print *,'ndims=', ndims
      print *,'M=', M
      print '(2(a,2f10.3))','xmin=', xmin, ' xmax=', xmax
      print *,'index mapping=', map_x_indices 

      call xgrid_init(this, xmin, xmax, M, map_x_indices, ier)

      indices = (/1, 0, 0/)
      call xgrid_get(this, indices, x, ier)
      print *,'indices=', indices
      print '(a,2f10.3)', ' x=',x

      indices = (/2, 0, 0/)
      call xgrid_get(this, indices, x, ier)
      print *,'indices=', indices
      print '(a,2f10.3)',' x=',x
      
      indices = (/2, 5, 0/)
      call xgrid_get(this, indices, x, ier)
      print *,'indices=', indices 
      print '(a,2f10.3)',' x=',x

      indices = (/2, 0, 8/)
      call xgrid_get(this, indices, x, ier)
      print *,'indices=', indices
      print '(a,2f10.3)',' x=',x

      indices = (/2, 5, 8/)
      call xgrid_get(this, indices, x, ier)
      print *,'indices=', indices
      print '(a,2f10.3)',' x=',x

      call xgrid_free(this, ier)

    end subroutine xgrid_test

end module xgrid

program tester

  implicit none
  integer input

  print *, 'GACO module tester'
  print *, '0: all test runs'
  print *, '1: plotmtv'
  print *, '2: indexer'
  print *, '2: gabor'
  print *, '3: kzgrid'
  print *, '4: xgrid'
  print *, '5: sparseC16'
  read(5,*) input

  select case(input)

     case(1)
        call plotmtv_test_run
     case(2)
        call indexer_test_run
     case(3)
        call gabor_test_run
     case(4)
        call kzgrid_test_run
     case(5)
        call xgrid_test_run
     case(6)
        call sparseC16_test_run
     case default
        call plotmtv_test_run
        call indexer_test_run
        call gabor_test_run
        call kzgrid_test_run
        call xgrid_test_run
        call sparseC16_test_run
  end select

end program tester

subroutine plotmtv_test_run
  use plotmtv
  implicit none
  type(plotmtv_obj) :: this_plotmtv

  call plotmtv_test(this_plotmtv)
  
end subroutine plotmtv_test_run

subroutine indexer_test_run
  use indexer
  implicit none
  integer ier
  type(indexer_obj) :: this_indexer

  call indexer_test(this_indexer, ier)
  if(ier /=0 ) then
     print *,'indexer_test **FAILED**'
  else
     print *,'indexer_test SUCCEDED'
  endif

end subroutine indexer_test_run

subroutine gabor_test_run
  use gabor
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865_r8
  real(r8) :: x, z, delta_x, delta_k, sigma, ak
  real(r8), dimension(3) :: xs, zs, delta_xs, delta_ks, sigmas, aks

  x=0.212346_r8; delta_x = 0.1_r8; z=0.1_r8;
  sigma=1._r8/delta_x**2
  delta_k = twopi/(delta_x * 1.3_r8)
  ak = 2*delta_k
  print *,'k=',ak, ' x=',x,' z=', z
  print *,'Gabor0(x, z, ak, sigma)=', Gabor0(x, z, ak, sigma)
  xs = (/0._r8, x, 1._r8/)
  zs =  (/0._r8, z, 1._r8/)
  aks = (/0._r8, ak, 2*ak/)
  sigmas = sigma
  print *,'ks=',aks
  print *,'xs=',xs
  print *,'zs=', zs
  print *,'sigmas=', sigmas
  print *,'GaborN(xs, zs, aks, sigmas)=', GaborN(xs, zs, aks, sigmas)
  
end subroutine gabor_test_run

subroutine kzgrid_test_run
  use kzgrid
  implicit none
  integer ier
  type(kzgrid_obj) :: this_kzgrid  
  
  call kzgrid_test(this_kzgrid, ier)
  if(ier /=0 ) then
     print *,'kzgrid_test **FAILED**'
  else
     print *,'kzgrid_test SUCCEDED'
  endif

end subroutine kzgrid_test_run

subroutine xgrid_test_run
  use xgrid
  implicit none
  integer ier
  type(xgrid_obj) :: this_xgrid  
  
  call xgrid_test(this_xgrid, ier)
  if(ier /=0 ) then
     print *,'xgrid_test **FAILED**'
  else
     print *,'xgrid_test SUCCEDED'
  endif

end subroutine xgrid_test_run
  
subroutine sparseC16_test_run
  use supralu_mod
  implicit none
  integer ier
  type(sparseC16_obj) :: this_sparse

  call sparseC16_test(this_sparse, ier)
  if(ier /=0 ) then
     print *,'sparseC16_test **FAILED**'
  else
     print *,'sparseC16_test SUCCEDED'
  endif
  
end subroutine sparseC16_test_run

module operators

  ! Implements various operators

  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)
  complex(r8), parameter, private :: imag = (0._r8, 1._r8)
  character(*), parameter, private :: version = &
       & '$Id: operators.f90,v 1.6 2003/10/23 13:12:51 pletzer Exp $'

contains

  subroutine second_derivative(x, ak, z, sigma, res, ier)

    ! Returns the derivative of order 'order' / Gabor

    implicit none
    real(r8), intent(in) :: x, ak, z, sigma
    complex(r8), intent(out) :: res
    integer, intent(out) :: ier

    ier = 0
    res = (imag*ak - sigma*(x-z))**2 - sigma

  end subroutine second_derivative

  subroutine derivative(order, x, ak, z, sigma, res, ier)

    implicit none
    integer, intent(in) :: order
    real(r8), intent(in) :: x, ak, z, sigma
    complex(r8), intent(out) :: res
    integer, intent(out) :: ier

    real(r8) :: s

    s = sigma
    ier = 0
    select case (order)
    case(:-1)
       ier = 1
       res = -huge(1._r8) 
    case(0)
       res = 1
    case(1)
       res = (0,1)*ak + s*(-x + z)
    case(2)
       res = -s - (ak + (0,1)*s*(x - z))**2
    case(3)
       res = ((0,1)*ak + s*(-x + z))*(-3*s + ((0,1)*ak + s*(-x + z))**2)
    case(4)
       res = 3*s**2 + (ak + (0,1)*s*(x - z))**4 - 6*s*((0,-1)*ak + s*(x - z))**2
    case(5)
       res =          (15*s**2 + (ak + (0,1)*s*(x - z))**4 -  &
            & 10*s*((0,-1)*ak + s*(x - z))**2)*((0,1)*ak + s*(-x + z))

    case(6)
       res =          -15*s**3 - 15*s*(ak + (0,1)*s*(x - z))**4 +  &
            &  45*s**2*((0,-1)*ak + s*(x - z))**2 + ((0,1)*ak + s*(-x + z))**6

    case(7)
       res =          ((0,1)*ak + s*(-x + z))* &
            &  (-105*s**3 - 21*s*(ak + (0,1)*s*(x - z))**4 + &
            & 105*s**2*((0,-1)*ak + s*(x - z))**2 + ((0,1)*ak + s*(-x + z))**6)

    case(8)
       res =          105*s**4 + 210*s**2*(ak + (0,1)*s*(x - z))**4 + &
            &   (ak + (0,1)*s*(x - z))**8 - 420*s**3*((0,-1)*ak + s*(x - z))**2 - &
            &   28*s*((0,-1)*ak + s*(x - z))**6

    case(9)
       res =          (945*s**4 + 378*s**2*(ak + (0,1)*s*(x - z))**4 + &
            & (ak + (0,1)*s*(x - z))**8 - 1260*s**3*((0,-1)*ak + s*(x - z))**2 - &
            & 36*s*((0,-1)*ak + s*(x - z))**6)*((0,1)*ak + s*(-x + z))

    case(10)
       res =          -945*s**5 - 3150*s**3*(ak + (0,1)*s*(x - z))**4 - &
            &   45*s*(ak + (0,1)*s*(x - z))**8 + &
            &   4725*s**4*((0,-1)*ak + s*(x - z))**2 + &
            &   630*s**2*((0,-1)*ak + s*(x - z))**6 + ((0,1)*ak + s*(-x + z))**10

    case default
       ! not implemented
       ier = 2
       res = + huge(1._r8)
    end select
  end subroutine derivative


  subroutine curl_curl(ia, ib, x, ak, z, sigma, res, ier)

    implicit none
    integer, intent(in) :: ia, ib ! field components
    real(r8), intent(in) :: x(:) ! collocation position
    real(r8), intent(in) :: ak(:) ! Gabor wave-vector
    real(r8), intent(in) :: z(:) ! Gabor envelop position
    real(r8), intent(in) :: sigma(:) ! inverse Gabor extents
    complex(r8), intent(out) :: res ! result
    integer, intent(out) :: ier

    complex(r8) :: i_ktilde(size(x))

    ier = 0
    i_ktilde = imag*ak - sigma*(x-z)
    res = i_ktilde(ia)*i_ktilde(ib)
    if(ia==ib) then
       res = res - sigma(ia) - dot_product(i_ktilde,i_ktilde) &
            & + sum(sigma)
    endif
    
  end subroutine curl_curl

  

end module operators

module gabor

  integer, parameter, private :: r8 = selected_real_kind(12,100)
  complex(r8), parameter, private :: imag = (0._r8, 1._r8)
  character(*), parameter, private ::  version = &
       & '$Id: gabor.f90,v 1.4 2003/10/17 14:22:49 pletzer Exp $'

contains

  function Gabor0(x, z, ak, sigma)

    ! Scalar Gabor function

    implicit none
    complex(r8) Gabor0
    real(r8), intent(in) :: x ! collocation point
    real(r8), intent(in) :: z ! envelop position
    real(r8), intent(in) :: ak ! wave number
    real(r8), intent(in) :: sigma ! inverse extent

    Gabor0 = exp(imag*ak*x) * exp(-0.5_r8 * sigma * (x-z)**2)
  end function Gabor0

  function GaborN(x, z, ak, sigma)

    ! N-dimensional Gabor function 

    implicit none
    complex(r8) GaborN
    real(r8), intent(in) :: x(:) ! collocation point
    real(r8), intent(in) :: z(:) ! envelop position
    real(r8), intent(in) :: ak(:) ! wave number
    real(r8), intent(in) :: sigma(:) ! inverse extent

    GaborN = exp(imag*dot_product(ak,x)) * exp(-0.5_r8 * dot_product(sigma, (x-z)**2))
  end function GaborN

end module gabor

module plotmtv

  ! Interface to plotmtv

  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)
  character(*), parameter, private :: version = &
       & '$Id: plotmtv.f90,v 1.6 2003/12/16 15:51:05 pletzer Exp $'
  
  type plotmtv_obj
     integer :: plotid ! id number
     logical :: hold ! set this to true for multiplots
     logical :: save ! set this to true if file needs to be saved
     logical :: freshstart ! true if new file is to be created
     logical :: display ! true to dosplay plot
     character(80) :: toplabel, xlabel, ylabel, zlabel, linelabel
     integer :: linewidth ! 1-32
     integer :: markersize ! 1-30
     integer :: fontsize ! 1-30
  end type plotmtv_obj

contains

  subroutine plotmtv_init(this)  
    implicit none
    type(plotmtv_obj) :: this

    real harvest
    call random_number(harvest)
    this % plotid = int(100000000 * harvest)
    this % hold = .FALSE.
    this % save = .FALSE.
    this % freshstart = .TRUE.
    this % display = .TRUE.
    this % toplabel = " "
    this % xlabel = " "
    this % ylabel = " "
    this % zlabel = " "
    this % linelabel = " "
    this % linewidth = 1
    this % markersize = 1
    this % fontsize = 10
  end subroutine plotmtv_init

  subroutine plotmtv_free(this)    
    implicit none
    type(plotmtv_obj) :: this
    character(12) nid
    
    if(.not. this % save) then
       write(nid,'(i12)') this % plotid
       print *,'rm table'//trim(adjustl(nid))//'.mtv'
       call system('rm table'//trim(adjustl(nid))//'.mtv')
    endif
  end subroutine plotmtv_free

  subroutine plotmtv_plot(this, x, y, line, marker)
   
     ! Dump x and y into file tableN.mtv where N is the plotid. Fire
     ! plotmtv if display = true. Multiple line plots are obtained
     ! by calling plot in sequence and setting hold = true.

 
    implicit none
    type(plotmtv_obj) :: this
    real(r8), intent(in) :: x(:), y(:)
    character(*) :: line, marker
    character(40) :: filename
    character(10) :: nid 

    integer linecolor, linetype, markertype, markercolor, i
    
    call plotmtv_set_color(marker(1:1), markercolor) 
    call plotmtv_set_marker(marker(2:2), markertype)
    call plotmtv_set_color(line(1:1), linecolor) 
    call plotmtv_set_line(line(2:2), linetype) 

    write(nid, '(i10)') this % plotid
    filename = 'table'//trim(adjustl(nid))//'.mtv'
    if(this % freshstart) then
       open(this % plotid, file=trim(filename), form='formatted', status='unknown')
    else
       open(this % plotid, file=trim(filename), form='formatted', status='unknown', &
            & position='append')
    endif
    write(this % plotid, *) ' '
    if(.not. this % hold) write(this % plotid, '(a)') "$DATA=COLUMN"
    write(this % plotid, '(a,a,a)') '%toplabel = "', trim(this % toplabel),'"'
    write(this % plotid, '(a,a,a)') '%xlabel = "', trim(this % xlabel),'"'
    write(this % plotid, '(a,a,a)') '%ylabel = "', trim(this % ylabel),'"'
    write(this % plotid, '(a,a,a)') '%linelabel = "', trim(this % linelabel),'"'
    write(this % plotid, '(a,i10)') '%linetype = ', linetype
    write(this % plotid, '(a,i10)') '%linewidth = ', this % linewidth
    write(this % plotid, '(a,i10)') '%linecolor = ', linecolor
    write(this % plotid, '(a,i10)') '%markertype = ', markertype
    write(this % plotid, '(a,i10)') '%markercolor = ', markercolor
    write(this % plotid, '(a,i10)') '%markersize = ', this % markersize
    write(this % plotid, *) 'x y'
    do i = 1, size(x)
       write(this % plotid, '(e13.5,e13.5)' ) x(i), y(i)
    end do
    close(this % plotid)

    ! fire
    if(this % display) then
       call system('plotmtv -bg white -fg black -geom 360x320 '// &
            & trim(filename)//' > plotmtv.log ')
    end if

    this % freshstart = .FALSE.

  end subroutine plotmtv_plot

  subroutine plotmtv_test(this)
    implicit none
    type(plotmtv_obj) :: this
    
    integer, parameter :: n = 101
    real(r8), dimension(n) :: x, y1, y2, y3
    real(r8) :: twopi
    integer i
    
    twopi = 2*acos(-1._r8)
    x = twopi*(/ (real(i-1,r8)/real(n-1,r8), i = 1, n) /)
    y1 = sin(x)
    y2 = sin(2*x)
    y3 = cos(3*x)
    
    call plotmtv_init(this)
    this % hold = .TRUE.  ! multigraph
    this % display = .FALSE. ! don't show
    this % xlabel = 'angle [rad]'
    this % ylabel = 'y'
    this % toplabel = ' test '
    this % linelabel = 'sin(x)'
    call plotmtv_plot(this, x, y1, 'r|', 'bx')
    this % linelabel = 'sin(2*x)'
    call plotmtv_plot(this, x, y2, 'g:', 'k^')
    this % display = .TRUE.
    this % linelabel = 'cos(3*x)'
    call plotmtv_plot(this, x, y3, 'm!', 'so')    
    ! call plotmtv_free(this)

  end subroutine plotmtv_test

! static members...................................................................

  subroutine plotmtv_set_line(line, code)
    implicit none
    character, intent(in) :: line
    integer, intent(out) :: code

    select case(line)
    case(' ')
       code = 0
    case('|')
       code = 1
    case('l')
       code = 2
    case('!')
       code = 4
    case(':')
       code = 3
    case default
       code = 3
    end select

  end subroutine plotmtv_set_line

  subroutine plotmtv_set_color(color, code)
    implicit none
    character, intent(in) :: color
    integer, intent(out) :: code

    select case(color)
    case(' ')
       code = -1
    case('k')
       code = 0
    case('y')
       code = 1
    case('c')
       code = 2
    case('g')
       code = 3
    case('r')
       code = 4
    case('b')
       code = 5
    case('m')
       code = 7
    case('p')
       code = 8
    case('s')
       code = 9
    case('n')
       code = 10
    case default
       code = -2 
    end select

  end subroutine plotmtv_set_color

  subroutine plotmtv_set_marker(marker, code)
    implicit none
    character, intent(in) :: marker
    integer, intent(out) :: code

    select case(marker)
    case(' ')
       code = 0
    case('.')
       code = 1
    case('+')
       code = 2
    case('x')
       code = 3
    case('s')
       code = 4
    case('l')
       code = 6
    case('^')
       code = 8
    case('v')
       code = 10
    case('o')
       code = 13
    case default
       code = -2
    end select
    
  end subroutine plotmtv_set_marker

end module plotmtv

! $Id: driver.f90,v 1.8 2003/12/22 13:29:55 pletzer Exp $

program driver
  implicit none
  integer input

  print *, 'GACO test driver'
  print *, '0: all test runs'
  print *, '1: ktae'
  print *, '2: eigenbessel'
  print *, '3: eigenwave'
  print *, '4: singular'
  print *, '5: Airy'
  print *, '6: order4'
  print *, '7: coupled'
  print *, 'select test case now '
  read(5,*) input
  
  select case(input)

     case (1)
        call ktae_test_run
     case (2)
        call eigenbessel_test_run
     case (3)
        call eigenwave_test_run
     case (4)
        call singular_test_run
     case (5)
        call Airy_test_run
     case (6)
        call order4_test_run
     case (7)
        call coupled_test_run
     case default
        call ktae_test_run
        call eigenbessel_test_run
        call eigenwave_test_run
        call singular_test_run
        call Airy_test_run
        call order4_test_run
        call coupled_test_run        

  end select

end program driver

!========================================================================
subroutine ktae_test_run
  use ktae
  implicit none
  type(ktae_obj) :: this
  call ktae_test(this)
end subroutine ktae_test_run

!========================================================================
!========================================================================
subroutine eigenbessel_test_run
  use eigenbessel
  implicit none
  type(eigenbessel_obj) :: this
  call eigenbessel_test(this)
end subroutine eigenbessel_test_run

!========================================================================
!========================================================================
subroutine eigenwave_test_run
  use eigenwave
  implicit none
  type(eigenwave_obj) :: this
  call eigenwave_test(this)
end subroutine eigenwave_test_run

!========================================================================
!========================================================================
subroutine singular_test_run
  use singular
  implicit none
  type(singular_obj) :: this
  call singular_test(this)
end subroutine singular_test_run

!========================================================================
!========================================================================
subroutine order4_test_run
  use order4
  implicit none
  type(order4_obj) :: this
  call order4_test(this)
end subroutine order4_test_run

!========================================================================
subroutine coupled_test_run
  use coupled
  implicit none
  type(coupled_obj) :: this
  call coupled_test(this)
end subroutine coupled_test_run
!========================================================================

subroutine Airy_test_run
  use airy
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  type(airy_obj) :: this

    integer :: Nz, Nj
    real(r8) sigma_dx2, sampling, xmin, xmax, tol, alpha, pi
    complex(r8) :: bc0, bc1
    real(r8), allocatable :: x(:)
    complex(r8), allocatable :: y(:), y_exact(:)
    real(r8) :: error

    integer n, i

    Nz = 20
    Nj = 5
    sigma_dx2 = 5 ! 2
    sampling = 2._r8    
    call airy_init(this, Nz, Nj, sigma_dx2, sampling)

    xmin = 0
    xmax = 1
    call airy_set_domain(this, xmin, xmax)

    tol = 1.e-8_r8
    call airy_set_tol(this, tol)

    pi = acos(-1._r8)
    alpha = 100*pi ! 11*pi/2._r8 ! 0
    call airy_set_equation(this, alpha)

    ! set the boundary conditions
    call gsl_sf_airy_ai((alpha/2._r8)**(2._r8/3._r8)*(2._r8*0._r8-1._r8), bc0)
    call gsl_sf_airy_ai((alpha/2._r8)**(2._r8/3._r8)*(2._r8*1._r8-1._r8), bc1)
    call airy_set_bcs(this, bc0, bc1)

    call airy_assemble(this)
    call airy_solve(this)

    n = this % iter2 % ntot * 5
    allocate(x(n), y(n), y_exact(n))
    do i = 1, n
       x(i) = xmin + (xmax-xmin)*real(i-1,r8)/real(n-1, r8)
       call gsl_sf_airy_ai((alpha/2._r8)**(2._r8/3._r8)*(2._r8*x(i)-1._r8), y_exact(i))
    end do
    call airy_get_solution(this, x, y)
    error = sqrt(sum( abs(y-y_exact)**2 )/n )
    print *,'alpha=', alpha, ' Nz=', Nz, ' Nj=', Nj, 'error = ', error
    call airy_plot(this, x, y)
    
    deallocate(x, y, y_exact)

    call airy_free(this)

  end subroutine Airy_test_run


!========================================================================

subroutine CurlCurl

  ! Example of test problem

  use indexer
  use operators
  use supralu_mod
  use gabor

  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795862320_r8
  
  type(indexer_obj) :: iter1, iter2
  type(sparseC16_obj) :: amat

  integer ier, all_inda(4), all_indb(7), ia, ib, i1, i2
  integer :: rank, nnz, base

  ! Grid sizes

  ! Gabor positions (range from 0:Nz)
  integer, parameter :: Nz(3) = (/2, 2, 2/)
  ! k-vector grid (Fourier modes range from -Nj:+Nj)
  integer, parameter :: Nj(3) = (/0, 0, 0/)
  ! No of components
  integer, parameter :: Nc = 1
  ! Collocation
  integer, parameter :: Nx(3) = (2*Nj+1)*(Nz+1)-1

  real(r8) :: kwav(3) ! wave-vector
  real(r8) :: zpos(3) ! envelop position
  real(r8) :: xpos(3) ! collocation position
  real(r8) :: delta_k(3), delta_x(3), delta_z(3)
  real(r8) :: sampling(3) ! sampling rate
  real(r8) :: sigma_dz2(3), sigma(3) ! inverse extent of envelopes
  real(r8) :: xmin(3), xmax(3), xmin_eps(3), xmax_eps(3)
  real(r8) :: tol, minus_log_tol ! sparsity tolerance
  complex(r8) :: val, gabor_fct
  complex(r8), allocatable :: x(:)
  logical newcol_flag
  real(r8) :: eps

  integer :: sizes2(7), start2(7)
  integer :: sizes1(4), start1(4)

  ! INPUTS

  ! Box boundaries
  xmin = 0
  xmax = 1

  ! Sampling rate
  sampling = (/1.1_r8, 1.5_r8, 2._r8/)

  ! Gabor inverse extent normalized to delta_z**2. delta_z is the Gabor separation
  sigma_dz2 = 1.5_r8

  delta_z = (xmax-xmin)/Nz
  delta_x = (xmax-xmin)/Nx
  delta_k = twopi/(delta_z * sampling)

  sigma = sigma_dz2 / delta_z**2

  tol = 1.e-10_r8
  minus_log_tol = -log(tol)
  eps = 10*epsilon(1._r8)

  ! ITERATOR SETUP
  
  ! Looping order: space components, then Fourier and finally 
  ! envelope positions
  sizes2 = (/Nc, 2*Nj(1)+1, 2*Nj(2)+1, 2*Nj(3)+1, Nz(1)+1, Nz(2)+1, Nz(3)+1/)
  start2 = (/ 1,  -Nj(1)  ,  -Nj(2)  ,  -Nj(3)  ,       0,       0,       0/)
  call indexer_init(iter2, sizes2, start2, ier)
  ! collocation looping:
  sizes1 = (/Nc, Nx(1)+1, Nx(2)+1, Nx(3)+1/)
  start1 = (/ 1,       0,       0,       0/)
  call indexer_init(iter1, sizes1, start1, ier)

  ! ASSEMBLY

  rank = iter1%ntot
  nnz = rank**2 !max(100000, int(1.0 * rank**2))
  base = 0
  call sparseC16_init(amat, rank, nnz, base, ier)
  call sparseC16_error(amat, 6, ier)

  ! right hand side vector
  allocate(x(iter1%ntot))
  x = 0  

  xmin_eps = xmin + eps
  xmax_eps = xmax - eps

  print *,'iter1%ntot=', iter1%ntot,' iter2%ntot=', iter2%ntot

  do i2 = 1, iter2%ntot
     ! Iterate over Gabors
     newcol_flag = .TRUE.
     call indexer_next(iter2, ier)
     call indexer_get(iter2, all_indb, ier)
     ib = all_indb(1)
     kwav = delta_k * all_indb(2:4)
     zpos = xmin + delta_z * all_indb(5:7)
     print *,'ib=',ib,' kwav=',kwav,' zpos=', zpos
     
     do i1 = 1, iter1%ntot
        ! Iterate over collocation points
        call indexer_next(iter1, ier)
        call indexer_get(iter1, all_inda, ier)
        ia = all_inda(1)
        xpos = xmin + delta_x * all_inda(2:4)
        gabor_fct = GaborN(xpos, zpos, kwav, sigma)

        if( all(xpos <= xmin_eps) ) then
           val = gabor_fct
           call sparseC16_set_next(amat, i1-1, newcol_flag, val, ier)
           call sparseC16_error(amat, 6, ier)
           newcol_flag = .FALSE.
           x(i1) = 0 ! BC at x=xmin
           cycle
        end if
        if( all(xpos >= xmax_eps) ) then
           val = gabor_fct
           call sparseC16_set_next(amat, i1-1, newcol_flag, val, ier)
           call sparseC16_error(amat, 6, ier)
           newcol_flag = .FALSE.
           if(ia==1) x(i1) = 1 ! BC at x=xmax
           cycle
        end if

        if (sum(0.5_r8*sigma*(xpos-zpos)**2) > minus_log_tol) cycle

        call curl_curl(ia, ib, xpos, kwav, zpos, sigma, val, ier)
        val = val * gabor_fct
        print *,'ia=',ia,' ib=',ib,' val=', val
        call sparseC16_set_next(amat, i1-1, newcol_flag, val, ier)
        call sparseC16_error(amat, 6, ier)
        newcol_flag = .FALSE.
     end do
  end do

  ! SOLVE
  
  call sparseC16_save(amat, 'amat.nc', ier)
  call sparseC16_error(amat, 6, ier)
  call sparseC16_solve(amat, x, ier)
  call sparseC16_error(amat, 6, ier)

  call indexer_free(iter1, ier)
  call indexer_free(iter2, ier)
  call sparseC16_free(amat, ier)
  deallocate(x)

end subroutine CurlCurl

module ktae

  ! Module for Eigenvalue Bessel test problem

  use supralu_mod
  use indexer
  use Gabor
  use kzgrid
  use xgrid
  use operators
  use plotmtv


  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)

  character(*), parameter, private :: version = &
       & '$Id: ktae.f90,v 1.6 2003/12/18 21:25:49 pletzer Exp $'
  integer, parameter  :: Nd = 1 ! space dimension
  integer, parameter  :: Nc = 1 ! no of components

  type ktae_obj
     integer :: Nz ! No of Gabor intervals
     integer :: Nj ! Fourier modes -Nj .. + Nj
     real(r8) :: sampling  ! sampling rate > 1
     real(r8) :: tol ! sparsity tolerance
     real(r8) :: xmin, xmax ! domain boundary
     
     ! equation parameters
     integer :: mpol, ntor ! poloidal/toroidal mode number
     real(r8) :: q0, q1    ! axis/edgesafety factor values
     real(r8) :: rhobar, rho_delta ! gyroradius

     real(r8) :: eps
     real(r8) :: sigma
     integer :: Nx
     type(sparseC16_obj) :: amat, bmat
     type(indexer_obj) :: iter2
     type(kzgrid_obj) :: kzg

  end type ktae_obj

contains

  subroutine ktae_init(this, Nz, Nj, sigma_dx2, sampling)
    implicit none
    type(ktae_obj) :: this
    integer, intent(in) :: Nz ! No of Gabor intervals
    integer, intent(in) :: Nj ! Fourier modes -Nj .. + Nj
    real(r8), intent(in)  :: sigma_dx2 ! inverse Gabor extent normalized to grid size
    real(r8), intent(in)  :: sampling  ! sampling rate > 1

    real(r8) :: delta_z

    this % xmin = 0
    this % xmax = 1
    this % tol = 1.e-10_r8

    this % mpol = 1
    this % ntor = 1
    this % q0 = 1.1_r8
    this % q1 = 2.1_r8
    this % rhobar = 0.01_r8
    this % rho_delta = 0

    this % Nz = Nz
    this % Nj = Nj
    delta_z = (this%xmax - this%xmin)/this%Nz
    this % sigma = sigma_dx2 / delta_z**2
    this % sampling = sampling

    this % eps = 10 * epsilon(1._r8)
    this % Nx = (2*Nj+1)*(Nz+1) - 1

  end subroutine ktae_init

  subroutine ktae_free(this)
    implicit none
    type(ktae_obj) :: this

    integer iok
    call sparseC16_free(this % amat, iok)
    call sparseC16_free(this % bmat, iok)
    call indexer_free(this % iter2, iok)
    call kzgrid_free(this % kzg, iok)
  end subroutine ktae_free

  subroutine ktae_set_domain(this, xmin, xmax)
    implicit none
    type(ktae_obj) :: this
    real(r8), intent(in) :: xmin, xmax ! domain boundary

    this % xmin = xmin
    this % xmax = xmax
    this % sigma = this % sigma/(xmax - xmin)**2
  end subroutine ktae_set_domain

  subroutine ktae_set_tol(this, tol)
    implicit none
    type(ktae_obj) :: this
    real(r8), intent(in) :: tol ! sparsity tolerance

    ! A low value of tol will make the matrices less sparse
    this % tol = max(this%eps, tol)
  end subroutine ktae_set_tol

  subroutine ktae_assemble(this)
    implicit none
    type(ktae_obj) :: this

    type(indexer_obj) :: iter1
    type(xgrid_obj) :: xg
    real(r8) :: minus_log_tol

    integer all_ind1(1+Nd), all_ind2(1+Nd*2), Nx(Nd), Nz(Nd), Nj(Nd)
    integer sizes1(1+Nd), starts1(1+Nd), sizes2(1+2*Nd), starts2(1+2*Nd)
    integer kz_map(2*Nd), x_map(Nd)
    real(r8) :: xmin(Nd), xmax(Nd), sigma(Nd)
    real(r8) :: sampling(Nd), xpos(Nd), kwav(Nd), zpos(Nd), dx(Nd), LARGE, x, xb
    complex(r8) :: val, gabor_fct, d1, d2, d3, d4, x4_del_square
    logical newcol_flag
    integer rank, ier, i, nnz, base, i2, i1, m

    ! In order to exercize iterators, the matrix 
    ! is assembled using the general, multi-dimensional
    ! iterator based method, although for a 1-d 
    ! equation it might be more efficient to use do-loops.

    xmin = this % xmin
    xmax = this % xmax
    dx = xmax - xmin
    sigma = this % sigma
    Nz = this % Nz
    Nj = this % Nj
    Nx = this % Nx
    sampling = this % sampling


    minus_log_tol = -log(this % tol) 

    ! iterators
    sizes1(1) = Nc; starts1(1) = 1;
    do i = 1, Nd
       sizes1(1+   i) = Nx(i)+1; starts1(1+   i) = 0
    end do
    call indexer_init(iter1, sizes1, starts1, ier)

    sizes2(1) = Nc; starts2(1) = 1;
    do i = 1, Nd
       sizes2(1+   i) = 2*Nj(i)+1; starts2(1+   i) = -Nj(i)
       sizes2(1+Nd+i) = Nz(i)  +1; starts2(1+Nd+i) = 0
    end do
    call indexer_init(this % iter2, sizes2, starts2, ier)

    ! grid data extractors
    do i = 1, Nd
       kz_map(i   ) = i   +1
       kz_map(i+Nd) = i+Nd+1
    end do
    call kzgrid_init(this % kzg, xmin, xmax, Nz, Nj, sampling, kz_map, ier)

    do i = 1, Nd
       x_map(i) = i + 1
    end do
    call xgrid_init(xg, xmin, xmax, Nx, x_map, ier)

    rank = iter1%ntot
    if(this % iter2%ntot /= rank) then
       print *,'Ktae::ERROR rank mismatch'
    endif
    nnz = rank**2 ! max no of elements
    base = 0
    call sparseC16_init(this % amat, rank, nnz, base, ier)
    call sparseC16_error(this % amat, 6, ier)
    call sparseC16_init(this % bmat, rank, nnz, base, ier)
    call sparseC16_error(this % bmat, 6, ier)

    ! start assembling

    do i2 = 1, this % iter2%ntot
       ! Iterate over Gabors
       newcol_flag = .TRUE.
       call indexer_next(this % iter2, ier)
       call indexer_get(this % iter2, all_ind2, ier)
       !ic2 = all_ind2(1) ! component
       ! get kwav & zpos
       call kzgrid_get(this % kzg, all_ind2, kwav, zpos, ier) 

       do i1 = 1, iter1%ntot
          ! Iterate over collocation points
          call indexer_next(iter1, ier)
          call indexer_get(iter1, all_ind1, ier)
          !ic1 = all_ind1(1) ! component
          ! get collocation point
          call xgrid_get(xg, all_ind1, xpos, ier)

          gabor_fct = GaborN(xpos, zpos, kwav, sigma)

          ! Boundary conditions

          ! Dirichlet are applied on the boundary collocation row
          if( abs(xpos(1)-xmin(1)) < this%eps ) then
             val = gabor_fct
             if(abs(val) > this % tol ) then
                call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
                call sparseC16_error(this % amat, 6, ier)

                call sparseC16_set_next(this % bmat, i1-1, newcol_flag, val, ier)
                call sparseC16_error(this % bmat, 6, ier)
                newcol_flag = .FALSE.
                cycle
             endif
          end if
          if( abs(xpos(1)-xmax(1)) < this%eps  ) then
             val = gabor_fct
             if(abs(val) > this % tol ) then
                call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
                call sparseC16_error(this % amat, 6, ier)

                call sparseC16_set_next(this % bmat, i1-1, newcol_flag, val, ier)
                call sparseC16_error(this % bmat, 6, ier)
                newcol_flag = .FALSE.
                cycle
             endif
          end if
          ! Higher order derivative BCs (modify row that is one node inside the domain)
          xb = xmin(1)+xg%delta_x(1)
          if( abs(xpos(1)-xb) < this%eps ) then
             gabor_fct = GaborN(xmin, zpos, kwav, sigma)
             if(this % mpol /= 1) then
                ! want y'(0) = 0 for m/=1
                call derivative(1, xmin(1), kwav(1), zpos(1), sigma(1), val, ier)
             else
                ! want y''(0) = 0 for m=1
                call derivative(2, xmin(1), kwav(1), zpos(1), sigma(1), val, ier)
             endif
             val = val * gabor_fct

             call sparseC16_set_next(this % bmat, i1-1, newcol_flag, val, ier)
             call sparseC16_error(this % bmat, 6, ier)

             call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
             call sparseC16_error(this % amat, 6, ier)             
             newcol_flag = .FALSE.
             cycle
          end if
          xb = xmax(1)-xg%delta_x(1)
          if( abs(xpos(1)-xb) < this%eps  ) then
             gabor_fct = GaborN(xmax, zpos, kwav, sigma)
             call derivative(1, xmax(1), kwav(1), zpos(1), sigma(1), val, ier)

             val = val * gabor_fct

             call sparseC16_set_next(this % bmat, i1-1, newcol_flag, val, ier)
             call sparseC16_error(this % bmat, 6, ier)

             call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
             call sparseC16_error(this % amat, 6, ier)             
             newcol_flag = .FALSE.
             cycle
          end if
          

          if (sum(0.5_r8*sigma*(xpos-zpos)**2) > minus_log_tol) cycle

          ! PDE operator

          call derivative(4, xpos(1), kwav(1), zpos(1), sigma(1), D4, ier)
          call derivative(3, xpos(1), kwav(1), zpos(1), sigma(1), D3, ier)
          call derivative(2, xpos(1), kwav(1), zpos(1), sigma(1), D2, ier)
          call derivative(1, xpos(1), kwav(1), zpos(1), sigma(1), D1, ier)

          x = xpos(1)
          m = this % mpol

          ! Left hand side

          ! x^4 rho^2 del^4
          val = m**2*(-4 + m**2) + x*((1 + 2*m**2)*D1 + x*(-((1 + 2*m**2)*D2) + x*(2*D3 + x*D4)))
          val = (this%rhobar*(1+(0,1)*this%rho_delta))**2 * val * gabor_fct

          ! x^4 del^2
          x4_del_square = x**2 *(x**2 *D2 + x*D1 - m**2) * gabor_fct

          val = val -  &
               & K_square(this, x,m)*x4_del_square - &
               & x**4 * K_square_prime(this, x,m)*gabor_fct*(D1 - 1/x) 

          
          call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
          call sparseC16_error(this % amat, 6, ier)
          

          ! Right hand side

          ! - x^4 del^2
          val = -  x4_del_square
          call sparseC16_set_next(this % bmat, i1-1, newcol_flag, val, ier)
          call sparseC16_error(this % bmat, 6, ier)

          newcol_flag = .FALSE.
       end do
    end do

    call sparseC16_compare_shapes(this%amat, this%bmat, ier)
    call sparseC16_error(this % amat, 6, ier)
    if(ier/=0) stop

    call indexer_free(iter1, ier)
    call xgrid_free(xg, ier)

  end subroutine ktae_assemble

  subroutine ktae_solve(this, xvec, lambda, nmax)
    implicit none
    type(ktae_obj) :: this
    complex(r8), intent(inout) :: xvec(:) ! initial eigenvector guess on input/eigenvector on output
    complex(r8), intent(inout) :: lambda ! initial eigenvalue guess on input/eigenvalue on output
    integer, intent(inout) :: nmax ! max number of iterations on input/no of iterations on output

    real(r8) :: tol

    integer ier

    complex(r8) :: res

    tol = 1.e-10_r8
    call sparseC16_eigen(this%amat, this%bmat, xvec, lambda, tol, nmax, ier) 

  end subroutine ktae_solve

  subroutine ktae_get_solution(this, xvec, x, y)
    implicit none
    type(ktae_obj) :: this
    complex(r8), intent(in) :: xvec(:) ! eigenvector returned by solve method
    real(r8), intent(in) :: x(:) ! abscissae 
    complex(r8), intent(out) :: y(:) ! ordinates

    integer n, i1, i2, ier, all_ind2(1+Nd*2)
    real(r8) :: kwav(Nd), zpos(Nd)

    y = 0
    n = size(x)
    if(n==0) return
    do i1 = 1, n
       y(i1) = 0
       this % iter2 % counter = 0 ! reset
       do i2 = 1, this % iter2 % ntot
          call indexer_next(this % iter2, ier)
          call indexer_get(this % iter2, all_ind2, ier)
          !ic2 = all_ind2(1) ! component
          ! get kwav & zpos
          call kzgrid_get(this % kzg, all_ind2, kwav, zpos, ier)
          y(i1) = y(i1) + xvec(this % iter2%counter)* &
               & GaborN( (/x(i1)/), zpos, kwav, (/this % sigma/))
       end do
    end do
  end subroutine ktae_get_solution

  subroutine ktae_plot(this, x, y, title)
    implicit none
    type(ktae_obj) :: this
    type(plotmtv_obj) :: plt_obj
    real(r8), intent(in) :: x(:) ! abscissae
    complex(r8), intent(in) :: y(:) ! ordinates
    character(*), intent(in) :: title

    call plotmtv_init(plt_obj)
    plt_obj % toplabel = 'Ktae '//trim(adjustl(title))
    plt_obj % xlabel = 'x'
    plt_obj % ylabel = 'y'
    plt_obj % linelabel = 'Re'
    plt_obj % display = .FALSE.
    plt_obj % hold = .TRUE.
    call plotmtv_plot(plt_obj, x, real(y), 'b|', '  ') 
    plt_obj % linelabel = 'Im'
    plt_obj % display = .TRUE.
    call plotmtv_plot(plt_obj, x, aimag(y), 'rl', '  ')
    call plotmtv_free(plt_obj)

  end subroutine ktae_plot

  subroutine ktae_test(this)

    ! Test module 

    use supralu_mod, only : sparseC16_get_size
    implicit none
    type(ktae_obj) :: this
    integer :: Nz, Nj, nmax
    real(r8) sigma_dx2, sampling, xmin, xmax, tol
    real(r8), allocatable :: x(:)
    complex(r8), allocatable :: y(:), xvec(:)
    complex(r8) :: lambda
    character(len=80) :: title
    

    integer n, i, ier, nrows, ncols

    Nz = 10 !! 20
    Nj = 2 !! 5
    sigma_dx2 = 2
    sampling = 1.5_r8    
    call ktae_init(this, Nz, Nj, sigma_dx2, sampling)

    xmin = 0
    xmax = 1
    call ktae_set_domain(this, xmin, xmax)

    tol = 1.e-6_r8 !! 1.e-10_r8
    call ktae_set_tol(this, tol)

    this % mpol = 1
    this % ntor = 1

    this % q0 = 2
    this % q1 = 2.1
    this % rhobar = 0.1_r8 ! 0.01_r8
    this % rho_delta = 0

    call ktae_assemble(this)
    call sparseC16_save(this%amat, 'amat.nc', ier)
    call sparseC16_save(this%bmat, 'bmat.nc', ier)
    call sparseC16_get_size(this%amat, nrows, ncols, ier)
    allocate(xvec(ncols))
    xvec = 1 ! initial eigenvector guess
    lambda = 0.262984_r8 !0.271574_r8 !0.493198_r8 !0.410244_r8 ! 0.638599_r8 !0.346723_r8 !0.29076_r8  ! initial eigenvalue guess
    lambda = 0.5236810816371932_r8 ! 0.55_r8 !0.51_r8
    nmax = 20 ! max no of iterations
    call ktae_solve(this, xvec, lambda, nmax)
    print *,'Eigenvalue = ', lambda, ' obtained after ', nmax, ' iterations'

    n = this % iter2 % ntot * 10
    allocate(x(n), y(n))
    x = this%xmin + (this%xmax-this%xmin)*(/ (real(i-1,r8)/real(n-1, r8), i=1,n) /)
    call ktae_get_solution(this, xvec, x, y)
    ! normalize
    y = y / maxval(abs(y))
    write(title, '(a,2f10.4)') 'Lambda=', lambda
    call ktae_plot(this, x, y, title)
    deallocate(x, y)
    deallocate(xvec)

    call ktae_free(this)


  end subroutine ktae_test

!...................................................................................
! extra methods

  function q(this, x)

    ! safety factor profile

    implicit none
    type(ktae_obj) :: this
    real(r8), intent(in) :: x
    real(r8) :: q
    q = this%q0 * (1 + (this%q1/this%q0 - 1) * x**2)

  end function q

  function q_prime(this, x)

    ! derivative of safety factor profile

    implicit none
    type(ktae_obj) :: this
    real(r8), intent(in) :: x
    real(r8) :: q_prime
    q_prime = 2 * (this%q1 - this%q0) * x

  end function q_prime

  function K_square(this, x, m)

    implicit none
    type(ktae_obj) :: this
    real(r8), intent(in) :: x
    integer, intent(in) :: m
    real(r8) :: K_square
    
    K_square = (this%ntor - m/q(this,x))**2

  end function K_square

  function K_square_prime(this, x, m)

    implicit none
    type(ktae_obj) :: this
    real(r8), intent(in) :: x
    integer, intent(in) :: m
    real(r8) :: K_square_prime

    integer n
    real(r8) :: q0, q1

    q0 = this % q0
    q1 = this % q1
    n = this % ntor
    
    K_square_prime = (-4*m*(q0 - q1)*x*(m - n*q0 + n*(q0 - q1)*x**2))/ &
         & (-q0 + (q0 - q1)*x**2)**3

  end function K_square_prime

end module ktae

module eigenwave

  ! Module for Eigenvalue wave test problem

  use supralu_mod
  use indexer
  use Gabor
  use kzgrid
  use xgrid
  use operators
  use plotmtv


  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)
  real(r8), parameter, private :: twopi = 6.2831853071795865_r8

  character(*), parameter, private :: version = &
       & '$Id: eigenwave.f90,v 1.2 2003/12/15 16:52:21 pletzer Exp $'
  integer, parameter  :: Nd = 1 ! space dimension
  integer, parameter  :: Nc = 1 ! no of components

  type eigenwave_obj
     integer :: Nz ! No of Gabor intervals
     integer :: Nj ! Fourier modes -Nj .. + Nj
     real(r8) :: sampling  ! sampling rate > 1
     real(r8) :: tol ! sparsity tolerance
     real(r8) :: xmin, xmax ! domain boundary

     real(r8) :: eps
     real(r8) :: sigma
     integer :: Nx
     type(sparseC16_obj) :: amat, bmat
     type(indexer_obj) :: iter2
     type(kzgrid_obj) :: kzg

  end type eigenwave_obj

contains

  subroutine eigenwave_init(this, Nz, Nj, sigma_dx2, sampling)
    implicit none
    type(eigenwave_obj) :: this
    integer, intent(in) :: Nz ! No of Gabor intervals
    integer, intent(in) :: Nj ! Fourier modes -Nj .. + Nj
    real(r8), intent(in)  :: sigma_dx2 ! inverse Gabor extent normalized to grid size
    real(r8), intent(in)  :: sampling  ! sampling rate > 1

    real(r8) :: delta_z

    this % xmin = 0
    this % xmax = twopi
    this % tol = 1.e-10_r8

    this % Nz = Nz
    this % Nj = Nj
    delta_z = (this%xmax - this%xmin)/this%Nz
    this % sigma = sigma_dx2 / delta_z**2
    this % sampling = sampling

    this % eps = 10 * epsilon(1._r8)
    this % Nx = (2*Nj+1)*(Nz+1) - 1

  end subroutine eigenwave_init

  subroutine eigenwave_free(this)
    implicit none
    type(eigenwave_obj) :: this

    integer iok
    call sparseC16_free(this % amat, iok)
    call sparseC16_free(this % bmat, iok)
    call indexer_free(this % iter2, iok)
    call kzgrid_free(this % kzg, iok)
  end subroutine eigenwave_free

  subroutine eigenwave_set_domain(this, xmin, xmax)
    implicit none
    type(eigenwave_obj) :: this
    real(r8), intent(in) :: xmin, xmax ! domain boundary

    this % xmin = xmin
    this % xmax = xmax
    this % sigma = this % sigma/(xmax - xmin)**2
  end subroutine eigenwave_set_domain

  subroutine eigenwave_set_tol(this, tol)
    implicit none
    type(eigenwave_obj) :: this
    real(r8), intent(in) :: tol ! sparsity tolerance

    ! A low value of tol will make the matrices less sparse
    this % tol = max(this%eps, tol)
  end subroutine eigenwave_set_tol

  subroutine eigenwave_assemble(this)
    implicit none
    type(eigenwave_obj) :: this

    type(indexer_obj) :: iter1
    type(xgrid_obj) :: xg
    real(r8) :: minus_log_tol

    integer all_ind1(1+Nd), all_ind2(1+Nd*2), Nx(Nd), Nz(Nd), Nj(Nd)
    integer sizes1(1+Nd), starts1(1+Nd), sizes2(1+2*Nd), starts2(1+2*Nd)
    integer kz_map(2*Nd), x_map(Nd)
    real(r8) :: xmin(Nd), xmax(Nd), sigma(Nd)
    real(r8) :: sampling(Nd), xpos(Nd), kwav(Nd), zpos(Nd), dx(Nd), LARGE
    complex(r8) :: val, gabor_fct
    logical newcol_flag
    integer rank, ier, i, nnz, base, i2, i1

    ! In order to exercize iterators, the matrix 
    ! is assembled using the general, multi-dimensional
    ! iterator based method, although for a 1-d 
    ! equation it might be more efficient to use do-loops.

    xmin = this % xmin
    xmax = this % xmax
    dx = xmax - xmin
    LARGE = 1._r8/this % tol
    sigma = this % sigma
    Nz = this % Nz
    Nj = this % Nj
    Nx = this % Nx
    sampling = this % sampling


    minus_log_tol = -log(this % tol) 

    ! iterators
    sizes1(1) = Nc; starts1(1) = 1;
    do i = 1, Nd
       sizes1(1+   i) = Nx(i)+1; starts1(1+   i) = 0
    end do
    call indexer_init(iter1, sizes1, starts1, ier)

    sizes2(1) = Nc; starts2(1) = 1;
    do i = 1, Nd
       sizes2(1+   i) = 2*Nj(i)+1; starts2(1+   i) = -Nj(i)
       sizes2(1+Nd+i) = Nz(i)  +1; starts2(1+Nd+i) = 0
    end do
    call indexer_init(this % iter2, sizes2, starts2, ier)

    ! grid data extractors
    do i = 1, Nd
       kz_map(i   ) = i   +1
       kz_map(i+Nd) = i+Nd+1
    end do
    call kzgrid_init(this % kzg, xmin, xmax, Nz, Nj, sampling, kz_map, ier)

    do i = 1, Nd
       x_map(i) = i + 1
    end do
    call xgrid_init(xg, xmin, xmax, Nx, x_map, ier)

    rank = iter1%ntot
    if(this % iter2%ntot /= rank) then
       print *,'Eigenwave::ERROR rank mismatch'
    endif
    nnz = rank**2 ! max no of elements
    base = 0
    call sparseC16_init(this % amat, rank, nnz, base, ier)
    call sparseC16_error(this % amat, 6, ier)
    call sparseC16_init(this % bmat, rank, nnz, base, ier)
    call sparseC16_error(this % bmat, 6, ier)

    ! start assembling

    do i2 = 1, this % iter2%ntot
       ! Iterate over Gabors
       newcol_flag = .TRUE.
       call indexer_next(this % iter2, ier)
       call indexer_get(this % iter2, all_ind2, ier)
       !ic2 = all_ind2(1) ! component
       ! get kwav & zpos
       call kzgrid_get(this % kzg, all_ind2, kwav, zpos, ier) 

       do i1 = 1, iter1%ntot
          ! Iterate over collocation points
          call indexer_next(iter1, ier)
          call indexer_get(iter1, all_ind1, ier)
          !ic1 = all_ind1(1) ! component
          ! get collocation point
          call xgrid_get(xg, all_ind1, xpos, ier)

          gabor_fct = GaborN(xpos, zpos, kwav, sigma)

          if( all(xpos <= (xmin+dx*this%eps)) ) then
             val = gabor_fct * LARGE ! force y(xmin) -> 0
             call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
             call sparseC16_error(this % amat, 6, ier)
             call sparseC16_set_next(this % bmat, i1-1, newcol_flag, gabor_fct, ier)
             call sparseC16_error(this % bmat, 6, ier)
             newcol_flag = .FALSE.
             cycle
          end if
          if( all(xpos >= (xmax-dx*this%eps)) ) then
             val = gabor_fct * LARGE ! force y(xmax) -> 0
             call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
             call sparseC16_error(this % amat, 6, ier)
             call sparseC16_set_next(this % bmat, i1-1, newcol_flag, gabor_fct, ier)
             call sparseC16_error(this % bmat, 6, ier)
             newcol_flag = .FALSE.
             cycle
          end if

          if (sum(0.5_r8*sigma*(xpos-zpos)**2) > minus_log_tol) cycle

          ! PDE operator

          call derivative(2, xpos(1), kwav(1), zpos(1), sigma(1), val, ier)
          val = - val * gabor_fct ! - y''
          call sparseC16_set_next(this % amat, i1-1, newcol_flag, val, ier)
          call sparseC16_error(this % amat, 6, ier)
          
          val = 1 * gabor_fct ! y
          call sparseC16_set_next(this % bmat, i1-1, newcol_flag, val, ier)
          call sparseC16_error(this % bmat, 6, ier)

          newcol_flag = .FALSE.
       end do
    end do

    call sparseC16_compare_shapes(this%amat, this%bmat, ier)
    call sparseC16_error(this % amat, 6, ier)
    if(ier/=0) stop

    call indexer_free(iter1, ier)
    call xgrid_free(xg, ier)

  end subroutine eigenwave_assemble

  subroutine eigenwave_solve(this, xvec, lambda, nmax)
    implicit none
    type(eigenwave_obj) :: this
    complex(r8), intent(inout) :: xvec(:) ! initial egenvector guess on input/eigenvector on output
    complex(r8), intent(inout) :: lambda ! initial egenvalue guess on input/eigenvalue on output
    integer, intent(inout) :: nmax ! max number of iterations on input/no of iterations on output

    real(r8) :: tol

    integer ier

    tol = 1.e-10_r8
    call sparseC16_eigen(this%amat, this%bmat, xvec, lambda, tol, nmax, ier)

  end subroutine eigenwave_solve

  subroutine eigenwave_get_solution(this, xvec, x, y)
    implicit none
    type(eigenwave_obj) :: this
    complex(r8), intent(in) :: xvec(:) ! eigenvector returned by solve method
    real(r8), intent(in) :: x(:) ! abscissae 
    complex(r8), intent(out) :: y(:) ! ordinates

    integer n, i1, i2, ier, all_ind2(1+Nd*2)
    real(r8) :: kwav(Nd), zpos(Nd)

    y = 0
    n = size(x)
    if(n==0) return
    do i1 = 1, n
       y(i1) = 0
       this % iter2 % counter = 0 ! reset
       do i2 = 1, this % iter2 % ntot
          call indexer_next(this % iter2, ier)
          call indexer_get(this % iter2, all_ind2, ier)
          !ic2 = all_ind2(1) ! component
          ! get kwav & zpos
          call kzgrid_get(this % kzg, all_ind2, kwav, zpos, ier)
          y(i1) = y(i1) + xvec(this % iter2%counter)* &
               & GaborN( (/x(i1)/), zpos, kwav, (/this % sigma/))
       end do
    end do
  end subroutine eigenwave_get_solution

  subroutine eigenwave_plot(this, x, y, title)
    implicit none
    type(eigenwave_obj) :: this
    type(plotmtv_obj) :: plt_obj
    real(r8), intent(in) :: x(:) ! abscissae
    complex(r8), intent(in) :: y(:) ! ordinates
    character(*), intent(in) :: title

    call plotmtv_init(plt_obj)
    plt_obj % toplabel = 'Eigenwave '//trim(adjustl(title))
    plt_obj % xlabel = 'x'
    plt_obj % ylabel = 'y'
    plt_obj % linelabel = 'Re'
    plt_obj % display = .FALSE.
    plt_obj % hold = .TRUE.
    call plotmtv_plot(plt_obj, x, real(y), 'b|', '  ') 
    plt_obj % linelabel = 'Im'
    plt_obj % display = .TRUE.
    call plotmtv_plot(plt_obj, x, aimag(y), 'rl', '  ')
    call plotmtv_free(plt_obj)

  end subroutine eigenwave_plot

  subroutine eigenwave_test(this)

    ! Test module 

    use supralu_mod, only : sparseC16_get_size
    implicit none
    type(eigenwave_obj) :: this
    integer :: Nz, Nj, nmax
    real(r8) sigma_dx2, sampling, xmin, xmax, tol
    real(r8), allocatable :: x(:)
    complex(r8), allocatable :: y(:), xvec(:)
    complex(r8) :: lambda
    character(len=80) :: title
    

    integer n, i, ier, nrows, ncols

    Nz = 20
    Nj = 1
    sigma_dx2 = 4
    sampling = 1.5_r8    
    call eigenwave_init(this, Nz, Nj, sigma_dx2, sampling)

    xmin = 0
    xmax = twopi
    call eigenwave_set_domain(this, xmin, xmax)

    tol = 1.e-8_r8
    call eigenwave_set_tol(this, tol)

    call eigenwave_assemble(this)
    call sparseC16_save(this%amat, 'amat.nc', ier)
    call sparseC16_save(this%bmat, 'bmat.nc', ier)
    call sparseC16_get_size(this%amat, nrows, ncols, ier)
    allocate(xvec(ncols))
    xvec = 1 ! initial eigenvector guess
    lambda = 0.25_r8 ! initial eigenvalue guess
    nmax = 10 ! max no of iterations
    call eigenwave_solve(this, xvec, lambda, nmax)
    print *,'Eigenvalue = ', lambda, ' obtained after ', nmax, ' iterations'

    n = this % iter2 % ntot * 10
    allocate(x(n), y(n))
    x = this%xmin + (this%xmax-this%xmin)*(/ (real(i-1,r8)/real(n-1, r8), i=1,n) /)
    call eigenwave_get_solution(this, xvec, x, y)
    ! normalize
    y = y / maxval(abs(y))
    write(title, '(a,2f6.3)') 'Lambda=', lambda
    call eigenwave_plot(this, x, y, title)
    deallocate(x, y)
    deallocate(xvec)

    call eigenwave_free(this)


  end subroutine eigenwave_test


end module eigenwave

module supralu_mod

  ! Column-compressed-storage based sparse matrix container

  implicit none
  integer, parameter, private :: r8 = selected_real_kind(12,100)
  character(*), parameter, private :: version = &
       & '$Id: supralu_mod.f90,v 1.4 2003/12/22 17:24:29 pletzer Exp $'
  
  type sparseC16_obj
     integer, pointer :: irow(:)
     integer, pointer :: jcol_ptr(:)
     complex(r8), pointer :: values(:)
     integer :: size, size_ptr, nnz, col_counter
     integer :: base

     ! SuperLU stuff

     ! column permutation specification
     !   permc_spec = 0: natural ordering 
     !   permc_spec = 1: minimum degree on structure of A'*A
     !   permc_spec = 2: minimum degree on structure of A'+A
     !   permc_spec = 3: approximate minimum degree for unsymmetric matrices
     integer :: permc_spec 
     
  end type sparseC16_obj

  type sparseR8_obj
     integer, pointer :: irow(:)
     integer, pointer :: jcol_ptr(:)
     real(r8), pointer :: values(:)
     integer :: size, size_ptr, nnz, col_counter
     integer :: base

     ! SuperLU stuff

     ! column permutation specification
     !   permc_spec = 0: natural ordering 
     !   permc_spec = 1: minimum degree on structure of A'*A
     !   permc_spec = 2: minimum degree on structure of A'+A
     !   permc_spec = 3: approximate minimum degree for unsymmetric matrices
     integer :: permc_spec 
     
  end type sparseR8_obj

  contains
!===================================================================================

! complex*16

    subroutine sparseC16_init(this, rank, size, base, ier)

      ! Constructor.
      !
      ! rank: matrix rank (or approximation if not known)
      ! size: >= no of non-zero values to store. If 
      ! size turns out to be too tight, fresh arrays will be 
      ! reallocated and the data will be copied, however this may
      ! can cause performance degradation.
      !
      ! base: indexing base (0 like C or 1 like Fortran)

      implicit none
      type(sparseC16_obj) :: this
      integer, intent(in) :: rank
      integer, intent(in) :: size
      integer, intent(in) :: base
      integer, intent(out) :: ier

      integer jer

      ier = 0

      this % permc_spec = 2 ! seems to work best

      this % nnz = 0
      this % size_ptr = rank+1
      this % size = size
      this % base = base
      this % col_counter = 0
      allocate(this%irow(this%size), stat=jer)
      if(jer /= 0 ) then
         ier = 9
         return
      end if
      allocate(this%values(this%size), stat=jer)
      if(jer /= 0 ) then
         ier = 10
         return
      end if
      allocate(this%jcol_ptr(this%size_ptr), stat=jer)
      if(jer /= 0 ) then
         ier = 11
         return
      end if
      this%irow = 0
      this%jcol_ptr = 0
      this%values = 0
      if(jer /=0 ) ier = 1
      
    end subroutine sparseC16_init
    
    subroutine sparseC16_free(this, ier)

      ! Destructor

      implicit none
      type(sparseC16_obj) :: this
      integer, intent(out) :: ier

      integer jer

      ier = 0
      deallocate(this%irow, stat=jer)
      deallocate(this%values, stat=jer)
      deallocate(this%jcol_ptr, stat=jer)
      if(jer/=0) ier = 2
      
    end subroutine sparseC16_free

    subroutine sparseC16_copy(this, that, ier)

      ! Copy this into that. that should be unitialized.

      implicit none
      type(sparseC16_obj) :: this, that
      integer, intent(out) :: ier

      integer jer

      ier = 0
      that % nnz = this % nnz
      that % size_ptr = this % size_ptr
      that % size = this % size
      that % base = this % base
      that % col_counter = this % col_counter
      allocate(that%irow(that%size), stat=jer)
      if(jer /= 0 ) then
         ier = 9
         return
      end if
      allocate(that%values(that%size), stat=jer)
      if(jer /= 0 ) then
         ier = 10
         return
      end if
      allocate(that%jcol_ptr(that%size_ptr), stat=jer)
      if(jer /= 0 ) then
         ier = 11
         return
      end if
      that % irow = this%irow
      that % jcol_ptr = this%jcol_ptr
      that % values = this%values
      if(jer /=0 ) ier = 12
      
      
    end subroutine sparseC16_copy

    subroutine sparseC16_compare_shapes(this, that, ier)

      ! Compare two sparse matrices

      implicit none
      type(sparseC16_obj) :: this, that
      integer, intent(out) :: ier

      integer i

      ier = 0
      if(this%base /= that%base) then
         ier = 13
         return
      end if
      if(this%nnz /= that%nnz) then
         ier = 14
         return
      end if
      if(this%size_ptr /= that%size_ptr) then
         ier = 15
         return
      end if
      if(this%size /= that%size) then
         ier = 16
         return
      end if
      if(this%col_counter /= that%col_counter) then
         ier = 17
         return
      end if
      do i = 1, this%size_ptr
         if(this%jcol_ptr(i) /= that%jcol_ptr(i)) then
            ier = 18
            return 
         end if
      enddo
      do i = 1, this%size
         if(this%irow(i) /= that%irow(i)) then
            ier = 19
            return      
         end if
      enddo


    end subroutine sparseC16_compare_shapes

    subroutine sparseC16_set_next(this, row, newcol_flag, value, ier)

      ! Set next value. Must iterate down each column 
      ! running from left to right.
      !
    
      implicit none
      type(sparseC16_obj) :: this
      integer, intent(in) :: row 
      logical, intent(in) :: newcol_flag ! .TRUE. if new column, .FALSE. otherwise
      complex(r8), intent(in) :: value 
      integer, intent(out) :: ier

      ier = 0
      this % nnz = this % nnz + 1
      if(this % nnz > this % size) then         
         ier = 3
         return
      endif
      this % irow(this%nnz) = row
      this % values(this%nnz) = value
      if(newcol_flag) then
         this % col_counter = this % col_counter + 1
         this % jcol_ptr(this % col_counter) = this%nnz - 1 + this%base
      endif
      this % jcol_ptr(this % col_counter+1) = this%nnz + this%base
      
    end subroutine sparseC16_set_next

    subroutine sparseC16_get_size(this, nrows, ncols, ier)

      ! Return no of rows and columns

      implicit none
      type(sparseC16_obj) :: this
      integer, intent(out) :: nrows, ncols
      integer, intent(out) :: ier

      ier = 0
      nrows = maxval(this % irow)
      ncols = this % col_counter
    end subroutine sparseC16_get_size

    subroutine sparseC16_solve(this, rhs, ier)

      ! Solve matrix system
      
      implicit none
      type(sparseC16_obj) :: this
      complex(r8), intent(inout) :: rhs(:) ! right-hand side vector, solution vector upon return
      integer, intent(out) :: ier

      integer n, jer
      integer :: handle(8) ! opaque handle

      ier = 0
      n = size(rhs)

      ! note: we pass here address (1) of vectors to force passing the 
      ! arguments by reference. 
      call zsupralu_new(handle, &
           & this%values(1), this%irow(1), this%jcol_ptr(1), this%nnz, n, &
           & jer)
      call zsupralu_colperm(handle, this % permc_spec, jer)
      call zsupralu_lu(handle, jer)
      call zsupralu_solve(handle, rhs(1), jer)
      call zsupralu_del(handle, jer)

      if(jer/=0) ier = 8

    end subroutine sparseC16_solve

    subroutine sparseC16_det(this, res_mantissa, res_exponent, ier)

      ! Return the determinant of A in the form of 
      !
      ! res_mantissa * 2**res_exponent

      implicit none
      type(sparseC16_obj) :: this
      complex(r8), intent(out) :: res_mantissa
      integer, intent(out) :: res_exponent
      integer, intent(out) :: ier
      
      integer :: handle(8) ! opaque handle
      integer :: n, jer

      ier = 0
      n = this % col_counter
      call zsupralu_new(handle, &
           & this%values(1), this%irow(1), this%jcol_ptr(1), this%nnz, n, &
           & jer)
      call zsupralu_colperm(handle, this % permc_spec, jer)
      call zsupralu_lu(handle, jer)
      call zsupralu_determinant(handle, res_mantissa, res_exponent, jer)
      call zsupralu_del(handle, jer)
      if(jer/=0) ier = 20

    end subroutine sparseC16_det

    subroutine sparseC16_eigen(Amat, Bmat, x, lambda, tol, nmax, ier)

      ! Solve A * x = lambda B * x by inverse iterations

      implicit none
      type(sparseC16_obj) :: Amat, Bmat ! Must have the same sparsity pattern! 
      complex(r8), intent(inout) :: lambda ! initial guess/computed eigenvalue
      complex(r8), intent(inout) :: x(:) ! initial egenvector guess/computed eigenvector
      real(r8), intent(inout) :: tol ! tolerance
      integer, intent(inout) :: nmax ! max number of iterations      
      integer, intent(out) :: ier

      integer n, i
      complex(r8), allocatable :: rhs(:)
      real(r8) :: residue, norm
      complex(r8) :: newv_b_v, newv_b_newv
      type(sparseC16_obj) :: Cmat

      ier = 0
      n = size(x)
      allocate(rhs(n))
      call sparseC16_copy(Amat, Cmat, ier)
      
      do i = 1, nmax
         Cmat % values = Amat % values - lambda * Bmat % values
         call sparseC16_A_dot_x(Cmat, x, rhs, ier)
         residue = sqrt( dot_product(rhs, rhs) )
         if(residue < tol) exit
         
         call sparseC16_A_dot_x(Bmat, x, rhs, ier)
         x = rhs
         call sparseC16_save(Cmat, 'cmat.nc', ier)
         call sparseC16_solve(Cmat, x, ier)
         newv_b_v = dot_product(x, rhs)
         call sparseC16_A_dot_x(Bmat, x, rhs, ier)
         newv_b_newv = dot_product(x, rhs)
         lambda = lambda + newv_b_v/newv_b_newv
         print *,'iteration=', i,' lambda=', lambda, ' residue=', residue
         
         norm = sqrt(dot_product(x, x))
         x = x/norm
      end do
      nmax = i
      tol = residue

      call sparseC16_free(Cmat, ier)
      deallocate(rhs)

    end subroutine sparseC16_eigen

    subroutine sparseC16_A_dot_x(this, x, res, ier)

      ! matrix . x => res

      implicit none
      type(sparseC16_obj) :: this
      complex(r8), intent(in) :: x(:) ! vector
      complex(r8), intent(out) :: res(:) ! result
      integer, intent(out) :: ier

      integer i, k, rank, j

      ier = 0
      res = 0
      rank = maxval(this % irow) + 1 - this%base

      
      do j = this%base+1, rank
         do k = this%jcol_ptr(j)+1-this%base, this%jcol_ptr(j+1)-this%base
            i = this%irow(k) + 1 - this%base
            res(i) = res(i) + this%values(k)*x(j)
         enddo
      enddo
      
    end subroutine sparseC16_A_dot_x

    subroutine sparseC16_save(this, filename, ier)

    ! Save state in netCDF file 'filename'

    use ezcdf
    implicit none
    type(sparseC16_obj) :: this
    character(*), intent(in) :: filename
    integer, intent(out) :: ier

    integer ncid, jer
    ier = 0

    call cdf_open(ncid, filename, 'w', jer)

    call cdf_define(ncid, 'version', (/len_trim(version),0,0/), 'CHAR', jer)
    call cdf_define(ncid, 'size', this%size, jer)
    call cdf_define(ncid, 'size_ptr', this%size_ptr, jer)
    call cdf_define(ncid, 'nnz', this%nnz, jer)
    call cdf_define(ncid, 'col_counter', this%col_counter, jer)
    call cdf_define(ncid, 'base', this%base, jer)
    call cdf_define(ncid, 'irow', this%irow(1:this%nnz), jer)
    call cdf_define(ncid, 'jcol_ptr', this%jcol_ptr, jer)
    call cdf_define(ncid, 'values', this%values(1:this%nnz), jer)

    call cdf_write(ncid, 'version', version, jer)
    call cdf_write(ncid, 'size', this%size, jer)
    call cdf_write(ncid, 'size_ptr', this%size_ptr, jer)
    call cdf_write(ncid, 'nnz', this%nnz, jer)
    call cdf_write(ncid, 'col_counter', this%col_counter, jer)
    call cdf_write(ncid, 'base', this%base, jer)
    call cdf_write(ncid, 'irow', this%irow(1:this%nnz), jer)
    call cdf_write(ncid, 'jcol_ptr', this%jcol_ptr, jer)
    call cdf_write(ncid, 'values', this%values(1:this%nnz), jer)

    call cdf_close(ncid, jer) 
    if(jer /= 0) ier = 4

    end subroutine sparseC16_save

    subroutine sparseC16_load(this, filename, ier)

      ! Load state from netCDF file 'filename'

    use ezcdf
    implicit none
    type(sparseC16_obj) :: this
    character(*), intent(in) :: filename
    integer, intent(out) :: ier

    integer ncid, jer
    ier = 0

    call cdf_open(ncid, filename, 'r', jer)

    call cdf_read(ncid, 'size', this%size, jer)
    call cdf_read(ncid, 'size_ptr', this%size_ptr, jer)
    call cdf_read(ncid, 'nnz', this%nnz, jer)
    call cdf_read(ncid, 'col_counter', this%col_counter, jer)
    call cdf_read(ncid, 'base', this%base, jer)
    allocate(this % irow(this%size), stat=jer)
    allocate(this % jcol_ptr(this%size_ptr), stat=jer)
    allocate(this % values(this%size), stat=jer)
    if(jer /= 0) then 
       ier = 1
       return
    endif
    call cdf_read(ncid, 'irow', this%irow, jer)
    call cdf_read(ncid, 'jcol_ptr', this%jcol_ptr, jer)
    call cdf_read(ncid, 'values', this%values, jer)

    call cdf_close(ncid, jer) 
    if(jer /= 0) ier = 5
      
    end subroutine sparseC16_load

    subroutine sparseC16_test(this, ier)

      ! Test unit

      implicit none
      type(sparseC16_obj) :: this, that, amat, bmat
      integer, intent(out) :: ier

      integer rank, size, base, i, nmax
      real(r8) :: tol
      complex(r8), allocatable :: rhs(:), x(:), res(:), y(:)
      complex(r8) :: lambda, adet, bdet, adet_mantissa, bdet_mantissa
      integer :: adet_exponent, bdet_exponent
      real(r8) :: cum_error

      ier = 0
      cum_error = 0
      print *, 'testing sparseC16...', version

      base = 0 ! C-like
      rank = 5
      size = 10
      call sparseC16_init(this, rank, size, base, ier)
      ! matrix to store
      ! [ 0 2 x 7 x ]
      ! [ 1 3 x x x ]
      ! [ x x 4 x x ]
      ! [ x x 5 8 x ]
      ! [ x x 6 x 9 ]
      ! the result should be 
      ! irow = [0,1,0,1,2,3,4,0,3,4]
      ! jcol_ptr = [0,2,4,7,9]
      ! values = [0,1,2,3,4,5,6,7,8,9]
      print *, '...assembling'
      call sparseC16_set_next(this, 0, .TRUE., cmplx(0., 0., r8), ier)
      call sparseC16_set_next(this, 1, .FALSE., cmplx(1., 0., r8), ier)
      call sparseC16_set_next(this, 0, .TRUE., cmplx(2., 0., r8), ier)
      call sparseC16_set_next(this, 1, .FALSE., cmplx(3., 0., r8), ier)
      call sparseC16_set_next(this, 2, .TRUE., cmplx(4., 0., r8), ier)
      call sparseC16_set_next(this, 3, .FALSE., cmplx(5., 0., r8), ier)
      call sparseC16_set_next(this, 4, .FALSE., cmplx(6., 0., r8), ier)
      call sparseC16_set_next(this, 0, .TRUE., cmplx(7., 0., r8), ier)
      call sparseC16_set_next(this, 3, .FALSE., cmplx(8., 0., r8), ier)
      call sparseC16_set_next(this, 4, .TRUE., cmplx(9., 0., r8), ier)
!!$
!!$      call sparseC16_set_next(this, 0, .TRUE., cmplx(1., 0., r8), ier)
!!$      call sparseC16_set_next(this, 1, .TRUE., cmplx(2., 0., r8), ier)
!!$      call sparseC16_set_next(this, 2, .TRUE., cmplx(3., 0., r8), ier)
!!$      call sparseC16_set_next(this, 3, .TRUE., cmplx(4., 0., r8), ier)
!!$      call sparseC16_set_next(this, 4, .TRUE., cmplx(5., 0., r8), ier)      

      print *, '...saving'
      call sparseC16_save(this, 'sparseC16.nc', ier)
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      print *,'...freeing'
      call sparseC16_free(this, ier)
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      print *,'...loading'
      call sparseC16_load(this, 'sparseC16.nc', ier)
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      print *, '...saving'
      call sparseC16_save(this, 'sparseC16_2.nc', ier)
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      allocate(rhs(rank), x(rank), res(rank))
      rhs = (/ (i, i=1,rank) /)
      x = rhs
      print *, '...solving'
      call sparseC16_solve(this, x, ier)      
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      print *,'...checking'
      call sparseC16_A_dot_x(this, x, res, ier)
!!$      print *,'result=', x
      print *,'error = ', sqrt(abs(sum((res - rhs)**2)/rank))
      cum_error = cum_error + sqrt(abs(sum((res - rhs)**2)/rank))

      print *,'...copying'
      call sparseC16_copy(this, that, ier)
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      print *,'***********************************************************'
      print *,'CUMULATIVE ERROR = ', cum_error
      if(cum_error > 1.e-10_r8) then
         print *,' **TEST FAILED**'
      else
         print *,' TEST SUCCEEDED '
      endif
      print *,'***********************************************************'

      that % values = 2 * this % values
      lambda = 0.5_r8
      nmax = 10
      print *,'...solving eigenvalue problem'
      tol = 1.e-10_r8
      call sparseC16_eigen(this, that, x, lambda, tol, nmax, ier)
      call sparseC16_error(this, 6, ier)
      cum_error = cum_error + ier

      print *,'lambda = ', lambda
      print *,'x=', x
      print *,'tol=', tol
      print *,'nmax=', nmax

      call sparseC16_free(this, ier)
      call sparseC16_free(that, ier)

! following is matlab code
!!$>> amat=[1+i -1 0; -1 2 3; 0 1 1.];
!!$>> bmat=[1 0.5 0; 0.5 1 0.5; 0 0.5 1];
!!$>> format long
!!$>> det(amat)
!!$
!!$ans =
!!$
!!$   -2.00000000000000 - 1.00000000000000i
!!$
!!$
!!$>> det(bmat)
!!$
!!$ans =
!!$
!!$    0.5000
!!$
!!$>> eig(amat, bmat)
!!$
!!$ans =
!!$
!!$   4.71566270818199 + 1.09633481548510i
!!$   1.09003448414007 + 0.34566426719211i
!!$  -0.80569719232206 + 0.05800091732279i

      call sparseC16_init(amat, 3, 7, 0, ier)
      call sparseC16_set_next(amat, 0, .TRUE.,  cmplx( 1., 1., r8), ier)
      call sparseC16_set_next(amat, 1, .FALSE., cmplx(-1., 0., r8), ier)
      call sparseC16_set_next(amat, 0, .TRUE.,  cmplx(-1., 0., r8), ier)
      call sparseC16_set_next(amat, 1, .FALSE., cmplx( 2., 0., r8), ier)
      call sparseC16_set_next(amat, 2, .FALSE., cmplx( 1., 0., r8), ier)
      call sparseC16_set_next(amat, 1, .TRUE.,  cmplx( 3., 0., r8), ier)
      call sparseC16_set_next(amat, 2, .FALSE., cmplx( 1., 0., r8), ier)
      cum_error = cum_error + ier

      call sparseC16_init(bmat, 3, 7, 0, ier)
      call sparseC16_set_next(bmat, 0, .TRUE.,  cmplx( 1., 0., r8), ier)
      call sparseC16_set_next(bmat, 1, .FALSE., cmplx( .5, 0., r8), ier)
      call sparseC16_set_next(bmat, 0, .TRUE.,  cmplx( .5, 0., r8), ier)
      call sparseC16_set_next(bmat, 1, .FALSE., cmplx( 1., 0., r8), ier)
      call sparseC16_set_next(bmat, 2, .FALSE., cmplx( .5, 0., r8), ier)
      call sparseC16_set_next(bmat, 1, .TRUE.,  cmplx( .5, 0., r8), ier)
      call sparseC16_set_next(bmat, 2, .FALSE., cmplx( 1., 0., r8), ier)
      cum_error = cum_error + ier

      amat % permc_spec = 2
      call sparseC16_det(amat, adet_mantissa, adet_exponent, ier)
      call sparseC16_det(bmat, bdet_mantissa, bdet_exponent, ier)
      adet = adet_mantissa * 2._r8**adet_exponent
      bdet = bdet_mantissa * 2._r8**bdet_exponent
      print *,'det A = ', adet, ' det B = ', bdet
      cum_error = cum_error + abs(adet - cmplx(-2._r8, -1._r8))
      cum_error = cum_error + abs(bdet - cmplx( 0.5_r8, 0._r8))

      allocate(y(3))
      tol = 1.e-10_r8
      nmax = 10
      lambda = -0.8_r8; y = 1
      call sparseC16_eigen(amat, bmat, y, lambda, tol, nmax, ier)
      print *,'lambda = ', lambda
      print *,'x=', x
      print *,'tol=', tol
      print *,'nmax=', nmax
      print *,'-------------------------------------------------'
      cum_error = cum_error + abs(lambda -  cmplx(-0.80569719232206_r8, 0.05800091732279_r8))

      tol = 1.e-10_r8
      nmax = 10
      lambda = 0.5_r8; y = 1
      call sparseC16_eigen(amat, bmat, y, lambda, tol, nmax, ier)
      print *,'lambda = ', lambda
      print *,'x=', x
      print *,'tol=', tol
      print *,'nmax=', nmax
      print *,'-------------------------------------------------'
      cum_error = cum_error + abs(lambda -  cmplx(1.09003448414007_r8, 0.34566426719211_r8))

      tol = 1.e-10_r8
      nmax = 10
      lambda = 4.5_r8; y = 1
      call sparseC16_eigen(amat, bmat, y, lambda, tol, nmax, ier)
      print *,'lambda = ', lambda
      print *,'x=', x
      print *,'tol=', tol
      print *,'nmax=', nmax
      print *,'-------------------------------------------------'
      cum_error = cum_error + abs(lambda -  cmplx(4.71566270818199_r8, 1.09633481548510_r8))

      call sparseC16_free(amat, ier)
      call sparseC16_free(bmat, ier)

      deallocate(rhs, x, res)
      deallocate(y)

      print *,'***********************************************************'
      print *,'CUMULATIVE ERROR = ', cum_error
      if(cum_error > 1.e-6_r8) then
         print *,' **TEST FAILED**'
      else
         print *,' TEST SUCCEEDED '
      endif
      print *,'***********************************************************'

    end subroutine sparseC16_test

    subroutine sparseC16_error(this, nunit, ier)
      
      ! Error handler
      
      implicit none
      type(sparseC16_obj) :: this
      integer, intent(in) :: nunit ! output channel
      integer, intent(in) :: ier
      
      character(*), parameter :: header = 'SparseC16::'

    select case(ier)
       case(1)
          write(nunit, *) header//'ERROR while initializing'
       case(2)
          write(nunit, *) header//'ERROR while deallocating'
       case(3)
          write(nunit, *) &
               & header//'ERROR counter exceeded declared size ', this%size,' rank=', this%size_ptr-1
       case(4)
          write(nunit, *) header//'ERROR while saving'
       case(5)
          write(nunit, *) header//'ERROR while loading'
       case(6)
          write(nunit, *) header//'ERROR occurred in test unit'
       case(7)
          write(nunit, *) header//'ERROR method not implemented'
       case(8)
          write(nunit, *) header//'ERROR occurred in solve'
       case(9)
          write(nunit, *) header//'ERROR occurred when allocating "irow"'
       case(10)
          write(nunit, *) header//'ERROR occurred when allocating "values"'
       case(11)
          write(nunit, *) header//'ERROR occurred when allocating "jcol_ptr"'
       case(12)
          write(nunit, *) header//'ERROR occurred when copying'
       case(13)
          write(nunit, *) header//'WARNING "base" mismatch'
       case(14)
          write(nunit, *) header//'WARNING "nnz" mismatch'
       case(15)
          write(nunit, *) header//'WARNING "size_ptr" mismatch'
       case(16)
          write(nunit, *) header//'WARNING "size" mismatch'
       case(17)
          write(nunit, *) header//'WARNING "col_counter" mismatch'
       case(18)
          write(nunit, *) header//'WARNING "jcol_ptr" array differ'
       case(19)
          write(nunit, *) header//'WARNING "irow" array differ'
       case(20)
          write(nunit, *) header//'ERROR occurred  in det'
       
       case default
    end select    
      
      
    end subroutine sparseC16_error
    
!===================================================================================

! real*8

    subroutine sparseR8_init(this, rank, size, base, ier)

      ! Constructor.
      !
      ! rank: matrix rank (or approximation if not known)
      ! size: >= no of non-zero values to store. If 
      ! size turns out to be too tight, fresh arrays will be 
      ! reallocated and the data will be copied, however this may
      ! can cause performance degradation.
      !
      ! base: indexing base (0 like C or 1 like Fortran)

      implicit none
      type(sparseR8_obj) :: this
      integer, intent(in) :: rank
      integer, intent(in) :: size
      integer, intent(in) :: base
      integer, intent(out) :: ier

      integer jer

      ier = 0

      this % permc_spec = 2 ! seems to work best

      this % nnz = 0
      this % size_ptr = rank+1
      this % size = size
      this % base = base
      this % col_counter = 0
      allocate(this%irow(this%size), stat=jer)
      if(jer /= 0 ) then
         ier = 9
         return
      end if
      allocate(this%values(this%size), stat=jer)
      if(jer /= 0 ) then
         ier = 10
         return
      end if
      allocate(this%jcol_ptr(this%size_ptr), stat=jer)
      if(jer /= 0 ) then
         ier = 11
         return
      end if
      this%irow = 0
      this%jcol_ptr = 0
      this%values = 0
      if(jer /=0 ) ier = 1
      
    end subroutine sparseR8_init
    
    subroutine sparseR8_free(this, ier)

      ! Destructor

      implicit none
      type(sparseR8_obj) :: this
      integer, intent(out) :: ier

      integer jer

      ier = 0
      deallocate(this%irow, stat=jer)
      deallocate(this%values, stat=jer)
      deallocate(this%jcol_ptr, stat=jer)
      if(jer/=0) ier = 2
      
    end subroutine sparseR8_free

    subroutine sparseR8_copy(this, that, ier)

      ! Copy this into that. that should be unitialized.

      implicit none
      type(sparseR8_obj) :: this, that
      integer, intent(out) :: ier

      integer jer

      ier = 0
      that % nnz = this % nnz
      that % size_ptr = this % size_ptr
      that % size = this % size
      that % base = this % base
      that % col_counter = this % col_counter
      allocate(that%irow(that%size), stat=jer)
      if(jer /= 0 ) then
         ier = 9
         return
      end if
      allocate(that%values(that%size), stat=jer)
      if(jer /= 0 ) then
         ier = 10
         return
      end if
      allocate(that%jcol_ptr(that%size_ptr), stat=jer)
      if(jer /= 0 ) then
         ier = 11
         return
      end if
      that % irow = this%irow
      that % jcol_ptr = this%jcol_ptr
      that % values = this%values
      if(jer /=0 ) ier = 12
      
      
    end subroutine sparseR8_copy

    subroutine sparseR8_compare_shapes(this, that, ier)

      ! Compare two sparse matrices

      implicit none
      type(sparseR8_obj) :: this, that
      integer, intent(out) :: ier

      integer i

      ier = 0
      if(this%base /= that%base) then
         ier = 13
         return
      end if
      if(this%nnz /= that%nnz) then
         ier = 14
         return
      end if
      if(this%size_ptr /= that%size_ptr) then
         ier = 15
         return
      end if
      if(this%size /= that%size) then
         ier = 16
         return
      end if
      if(this%col_counter /= that%col_counter) then
         ier = 17
         return
      end if
      do i = 1, this%size_ptr
         if(this%jcol_ptr(i) /= that%jcol_ptr(i)) then
            ier = 18
            return 
         end if
      enddo
      do i = 1, this%size
         if(this%irow(i) /= that%irow(i)) then
            ier = 19
            return      
         end if
      enddo


    end subroutine sparseR8_compare_shapes

    subroutine sparseR8_set_next(this, row, newcol_flag, value, ier)

      ! Set next value. Must iterate down each column 
      ! running from left to right.
      !
    
      implicit none
      type(sparseR8_obj) :: this
      integer, intent(in) :: row 
      logical, intent(in) :: newcol_flag ! .TRUE. if new column, .FALSE. otherwise
      real(r8), intent(in) :: value 
      integer, intent(out) :: ier

      ier = 0
      this % nnz = this % nnz + 1
      if(this % nnz > this % size) then         
         ier = 3
         return
      endif
      this % irow(this%nnz) = row
      this % values(this%nnz) = value
      if(newcol_flag) then
         this % col_counter = this % col_counter + 1
         this % jcol_ptr(this % col_counter) = this%nnz - 1 + this%base
      endif
      this % jcol_ptr(this % col_counter+1) = this%nnz + this%base
      
    end subroutine sparseR8_set_next

    subroutine sparseR8_get_size(this, nrows, ncols, ier)

      ! Return no of rows and columns

      implicit none
      type(sparseR8_obj) :: this
      integer, intent(out) :: nrows, ncols
      integer, intent(out) :: ier

      ier = 0
      nrows = maxval(this % irow)
      ncols = this % col_counter
    end subroutine sparseR8_get_size

    subroutine sparseR8_solve(this, rhs, ier)

      ! Solve matrix system
      
      implicit none
      type(sparseR8_obj) :: this
      real(r8), intent(inout) :: rhs(:) ! right-hand side vector, solution vector upon return
      integer, intent(out) :: ier

      integer n, jer
      integer :: handle(8) ! opaque handle

      ier = 0
      n = size(rhs)

      ! note: we pass here address (1) of vectors to force passing the 
      ! arguments by reference. 
      call dsupralu_new(handle, &
           & this%values(1), this%irow(1), this%jcol_ptr(1), this%nnz, n, &
           & jer)
      call dsupralu_colperm(handle, this % permc_spec, jer)
      call dsupralu_lu(handle, jer)
      call dsupralu_solve(handle, rhs(1), jer)
      call dsupralu_del(handle, jer)

      if(jer/=0) ier = 8

    end subroutine sparseR8_solve

    subroutine sparseR8_det(this, res_mantissa, res_exponent, ier)

      ! Return the determinant of A in the form of 
      !
      ! res_mantissa * 2**res_exponent

      implicit none
      type(sparseR8_obj) :: this
      real(r8), intent(out) :: res_mantissa
      integer, intent(out) :: res_exponent
      integer, intent(out) :: ier
      
      integer :: handle(8) ! opaque handle
      integer :: n, jer

      ier = 0
      n = this % col_counter
      call dsupralu_new(handle, &
           & this%values(1), this%irow(1), this%jcol_ptr(1), this%nnz, n, &
           & jer)
      call dsupralu_colperm(handle, this % permc_spec, jer)
      call dsupralu_lu(handle, jer)
      call dsupralu_determinant(handle, res_mantissa, res_exponent, jer)
      call dsupralu_del(handle, jer)
      if(jer/=0) ier = 20

    end subroutine sparseR8_det

    subroutine sparseR8_A_dot_x(this, x, res, ier)

      ! matrix . x => res

      implicit none
      type(sparseR8_obj) :: this
      real(r8), intent(in) :: x(:) ! vector
      real(r8), intent(out) :: res(:) ! result
      integer, intent(out) :: ier

      integer i, k, rank, j

      ier = 0
      res = 0
      rank = maxval(this % irow) + 1 - this%base

      
      do j = this%base+1, rank
         do k = this%jcol_ptr(j)+1-this%base, this%jcol_ptr(j+1)-this%base
            i = this%irow(k) + 1 - this%base
            res(i) = res(i) + this%values(k)*x(j)
         enddo
      enddo
      
    end subroutine sparseR8_A_dot_x

    subroutine sparseR8_save(this, filename, ier)

    ! Save state in netCDF file 'filename'

    use ezcdf
    implicit none
    type(sparseR8_obj) :: this
    character(*), intent(in) :: filename
    integer, intent(out) :: ier

    integer ncid, jer
    ier = 0

    call cdf_open(ncid, filename, 'w', jer)

    call cdf_define(ncid, 'version', (/len_trim(version),0,0/), 'CHAR', jer)
    call cdf_define(ncid, 'size', this%size, jer)
    call cdf_define(ncid, 'size_ptr', this%size_ptr, jer)
    call cdf_define(ncid, 'nnz', this%nnz, jer)
    call cdf_define(ncid, 'col_counter', this%col_counter, jer)
    call cdf_define(ncid, 'base', this%base, jer)
    call cdf_define(ncid, 'irow', this%irow(1:this%nnz), jer)
    call cdf_define(ncid, 'jcol_ptr', this%jcol_ptr, jer)
    call cdf_define(ncid, 'values', this%values(1:this%nnz), jer)

    call cdf_write(ncid, 'version', version, jer)
    call cdf_write(ncid, 'size', this%size, jer)
    call cdf_write(ncid, 'size_ptr', this%size_ptr, jer)
    call cdf_write(ncid, 'nnz', this%nnz, jer)
    call cdf_write(ncid, 'col_counter', this%col_counter, jer)
    call cdf_write(ncid, 'base', this%base, jer)
    call cdf_write(ncid, 'irow', this%irow(1:this%nnz), jer)
    call cdf_write(ncid, 'jcol_ptr', this%jcol_ptr, jer)
    call cdf_write(ncid, 'values', this%values(1:this%nnz), jer)

    call cdf_close(ncid, jer) 
    if(jer /= 0) ier = 4

    end subroutine sparseR8_save

    subroutine sparseR8_load(this, filename, ier)

      ! Load state from netCDF file 'filename'

    use ezcdf
    implicit none
    type(sparseR8_obj) :: this
    character(*), intent(in) :: filename
    integer, intent(out) :: ier

    integer ncid, jer
    ier = 0

    call cdf_open(ncid, filename, 'r', jer)

    call cdf_read(ncid, 'size', this%size, jer)
    call cdf_read(ncid, 'size_ptr', this%size_ptr, jer)
    call cdf_read(ncid, 'nnz', this%nnz, jer)
    call cdf_read(ncid, 'col_counter', this%col_counter, jer)
    call cdf_read(ncid, 'base', this%base, jer)
    allocate(this % irow(this%size), stat=jer)
    allocate(this % jcol_ptr(this%size_ptr), stat=jer)
    allocate(this % values(this%size), stat=jer)
    if(jer /= 0) then 
       ier = 1
       return
    endif
    call cdf_read(ncid, 'irow', this%irow, jer)
    call cdf_read(ncid, 'jcol_ptr', this%jcol_ptr, jer)
    call cdf_read(ncid, 'values', this%values, jer)

    call cdf_close(ncid, jer) 
    if(jer /= 0) ier = 5
      
    end subroutine sparseR8_load

    subroutine sparseR8_test(this, ier)

      ! Test unit

      implicit none
      type(sparseR8_obj) :: this, that, amat, bmat
      integer, intent(out) :: ier

      integer rank, size, base, i, nmax
      ! **not needed: eigen vector C16 only (dmc): real(r8) :: tol
      real(r8), allocatable :: rhs(:), x(:), res(:), y(:)
      real(r8) :: lambda, adet, bdet, adet_mantissa, bdet_mantissa
      integer :: adet_exponent, bdet_exponent
      real(r8) :: cum_error

      ier = 0
      cum_error = 0
      print *, 'testing sparseR8...', version

      base = 0 ! C-like
      rank = 5
      size = 10
      call sparseR8_init(this, rank, size, base, ier)
      ! matrix to store
      ! [ 0 2 x 7 x ]
      ! [ 1 3 x x x ]
      ! [ x x 4 x x ]
      ! [ x x 5 8 x ]
      ! [ x x 6 x 9 ]
      ! the result should be 
      ! irow = [0,1,0,1,2,3,4,0,3,4]
      ! jcol_ptr = [0,2,4,7,9]
      ! values = [0,1,2,3,4,5,6,7,8,9]
      print *, '...assembling'
      call sparseR8_set_next(this, 0, .TRUE., 0._r8, ier)
      call sparseR8_set_next(this, 1, .FALSE., 1._r8, ier)
      call sparseR8_set_next(this, 0, .TRUE., 2._r8, ier)
      call sparseR8_set_next(this, 1, .FALSE., 3._r8, ier)
      call sparseR8_set_next(this, 2, .TRUE., 4._r8, ier)
      call sparseR8_set_next(this, 3, .FALSE., 5._r8, ier)
      call sparseR8_set_next(this, 4, .FALSE., 6._r8, ier)
      call sparseR8_set_next(this, 0, .TRUE., 7._r8, ier)
      call sparseR8_set_next(this, 3, .FALSE., 8._r8, ier)
      call sparseR8_set_next(this, 4, .TRUE., 9._r8, ier)

      print *, '...saving'
      call sparseR8_save(this, 'sparseR8.nc', ier)
      call sparseR8_error(this, 6, ier)
      cum_error = cum_error + ier

      print *,'...freeing'
      call sparseR8_free(this, ier)
      cum_error = cum_error + ier

      print *,'...loading'
      call sparseR8_load(this, 'sparseR8.nc', ier)
      call sparseR8_error(this, 6, ier)
      cum_error = cum_error + ier

      print *, '...saving'
      call sparseR8_save(this, 'sparseR8_2.nc', ier)
      call sparseR8_error(this, 6, ier)
      cum_error = cum_error + ier

      allocate(rhs(rank), x(rank), res(rank))
      rhs = (/ (i, i=1,rank) /)
      x = rhs
      print *, '...solving'
      call sparseR8_solve(this, x, ier)      
      cum_error = cum_error + ier
      call sparseR8_A_dot_x(this, x, res, ier)
      cum_error = cum_error + ier
      print *,'error = ', sqrt(abs(sum((res - rhs)**2)/rank))
      cum_error = cum_error + sqrt(abs(sum((res - rhs)**2)/rank))

      call sparseR8_copy(this, that, ier)
      call sparseR8_error(this, 6, ier)      
      cum_error = cum_error + ier

      that % values = 2 * this % values

      call sparseR8_free(this, ier)
      cum_error = cum_error + ier
      call sparseR8_free(that, ier)
      cum_error = cum_error + ier

!!$>> amat=[1. -1 0; -1 2 3; 0 1 1.];
!!$>> bmat=[1 0.5 0; 0.5 1 0.5; 0 0.5 1];
!!$>> det(amat)
!!$
!!$ans =
!!$
!!$    -2
!!$
!!$>> det(bmat)
!!$
!!$ans =
!!$
!!$    0.5000


      call sparseR8_init(amat, 3, 7, 0, ier)
      call sparseR8_set_next(amat, 0, .TRUE.,  1._r8, ier)
      call sparseR8_set_next(amat, 1, .FALSE.,-1._r8, ier)
      call sparseR8_set_next(amat, 0, .TRUE., -1._r8, ier)
      call sparseR8_set_next(amat, 1, .FALSE., 2._r8, ier)
      call sparseR8_set_next(amat, 2, .FALSE., 1._r8, ier)
      call sparseR8_set_next(amat, 1, .TRUE.,  3._r8, ier)
      call sparseR8_set_next(amat, 2, .FALSE., 1._r8, ier)
      cum_error = cum_error + ier

      call sparseR8_init(bmat, 3, 7, 0, ier)
      call sparseR8_set_next(bmat, 0, .TRUE.,  1._r8, ier)
      call sparseR8_set_next(bmat, 1, .FALSE., .5_r8, ier)
      call sparseR8_set_next(bmat, 0, .TRUE.,  .5_r8, ier)
      call sparseR8_set_next(bmat, 1, .FALSE., 1._r8, ier)
      call sparseR8_set_next(bmat, 2, .FALSE., .5_r8, ier)
      call sparseR8_set_next(bmat, 1, .TRUE.,  .5_r8, ier)
      call sparseR8_set_next(bmat, 2, .FALSE., 1._r8, ier)
      cum_error = cum_error + ier

      amat % permc_spec = 2
      call sparseR8_det(amat, adet_mantissa, adet_exponent, ier)
      call sparseR8_det(bmat, bdet_mantissa, bdet_exponent, ier)
      adet = adet_mantissa * 2._r8**adet_exponent
      bdet = bdet_mantissa * 2._r8**bdet_exponent
      print *,'det A = ',adet,' det B = ', bdet
      cum_error = cum_error + abs(adet - real(-2,r8))
      cum_error = cum_error + abs(bdet - 0.5_r8)

      deallocate(rhs, x, res)
      call sparseR8_free(amat, ier)
      call sparseR8_free(bmat, ier)

      print *,'***********************************************************'
      print *,'CUMULATIVE ERROR = ', cum_error
      if(cum_error > 1.e-10_r8) then
         print *,' **TEST FAILED**'
      else
         print *,' TEST SUCCEEDED '
      endif
      print *,'***********************************************************'

    end subroutine sparseR8_test

    subroutine sparseR8_error(this, nunit, ier)
      
      ! Error handler
      
      implicit none
      type(sparseR8_obj) :: this
      integer, intent(in) :: nunit ! output channel
      integer, intent(in) :: ier
      
      character(*), parameter :: header = 'SparseR8::'

    select case(ier)
       case(1)
          write(nunit, *) header//'ERROR while initializing'
       case(2)
          write(nunit, *) header//'ERROR while deallocating'
       case(3)
          write(nunit, *) &
               & header//'ERROR counter exceeded declared size ', this%size,' rank=', this%size_ptr-1
       case(4)
          write(nunit, *) header//'ERROR while saving'
       case(5)
          write(nunit, *) header//'ERROR while loading'
       case(6)
          write(nunit, *) header//'ERROR occurred in test unit'
       case(7)
          write(nunit, *) header//'ERROR method not implemented'
       case(8)
          write(nunit, *) header//'ERROR occurred in solve'
       case(9)
          write(nunit, *) header//'ERROR occurred when allocating "irow"'
       case(10)
          write(nunit, *) header//'ERROR occurred when allocating "values"'
       case(11)
          write(nunit, *) header//'ERROR occurred when allocating "jcol_ptr"'
       case(12)
          write(nunit, *) header//'ERROR occurred when copying'
       case(13)
          write(nunit, *) header//'WARNING "base" mismatch'
       case(14)
          write(nunit, *) header//'WARNING "nnz" mismatch'
       case(15)
          write(nunit, *) header//'WARNING "size_ptr" mismatch'
       case(16)
          write(nunit, *) header//'WARNING "size" mismatch'
       case(17)
          write(nunit, *) header//'WARNING "col_counter" mismatch'
       case(18)
          write(nunit, *) header//'WARNING "jcol_ptr" array differ'
       case(19)
          write(nunit, *) header//'WARNING "irow" array differ'
       case(20)
          write(nunit, *) header//'ERROR occurred  in det'
       
       case default
    end select    
      
      
    end subroutine sparseR8_error

end module supralu_mod

module indexer

! Indexer class. Useful to flatten a multi-dimensional indexed expansion
! onto a flat data structure. 

implicit none
character(*), parameter, private ::  version = &
     & '$Id: indexer.f90,v 1.7 2003/12/15 16:52:21 pletzer Exp $'

type indexer_obj
   integer counter ! flat array index
   integer ntot    ! flat array total size
   integer ndims   ! no of dimensions
   ! the following contain the sizes and starting indices 
   ! in each dimension
   integer, pointer :: sizes(:), start(:)
end type indexer_obj

contains

  subroutine indexer_init(this, sizes, start, ier)

    ! Constructor. 

    implicit none
    type(indexer_obj) :: this
    integer, intent(inout) :: sizes(:) ! An array containing the sizes 
    integer, intent(in) :: start(:)
    integer, intent(out) :: ier

    integer jer, j
    ier = 0
    this % counter = 0
    this % ndims = size(sizes)
    this % ntot = 1
    sizes = max(1, sizes)
    do j = 1, this % ndims
       this % ntot = this % ntot * sizes(j)
    enddo
    allocate(this % sizes(this % ndims), stat=jer)
    allocate(this % start(this % ndims), stat=jer)
    if(jer /= 0) ier = 1
    this % sizes = sizes
    this % start = start
  end subroutine indexer_init

  subroutine indexer_free(this, ier)
    
    ! Destructor

    implicit none
    type(indexer_obj) :: this
    integer, intent(out) :: ier
    
    integer jer
    ier = 0
    deallocate(this % sizes, stat=jer)
    deallocate(this % start, stat=jer)
    if(jer /= 0) ier = 2
  end subroutine indexer_free

  subroutine indexer_next(this, ier)

    ! Increment counter

    implicit none
    type(indexer_obj) :: this
    integer, intent(out) :: ier

    ier = 0
    this % counter = this % counter + 1
    if(this % counter > this % ntot) ier = 3

  end subroutine indexer_next

  subroutine indexer_get(this, indices, ier)

    ! Return sub-indices

    implicit none
    type(indexer_obj) :: this
    integer, intent(out) :: indices(:)
    integer, intent(out) :: ier

    integer j1, j2, periodicity(this % ndims)
    ier = 0
    periodicity = 1
    do j1 = 2, this % ndims
       periodicity(j1) = periodicity(j1-1) * this % sizes(j1-1)
    enddo
    indices = (this % counter - 1)/periodicity
    indices = mod(indices, this % sizes) + this % start
  end subroutine indexer_get

  subroutine indexer_save(this, filename, ier)

    ! Save state in netCDF file 'filename'

    use ezcdf
    implicit none
    type(indexer_obj) :: this
    character(*), intent(in) :: filename
    integer, intent(out) :: ier

    integer ncid, jer
    ier = 0
    call cdf_open(ncid, filename, 'w', jer)
    call cdf_define(ncid, 'version', (/len_trim(version),0,0/), 'CHAR', jer)
    call cdf_define(ncid, 'counter', (/0,0,0/), 'INT', jer)
    call cdf_define(ncid, 'ndims', (/0,0,0/), 'INT', jer)
    call cdf_define(ncid, 'sizes', (/this % ndims, 0, 0/), 'INT', jer)
    call cdf_define(ncid, 'start', (/this % ndims, 0, 0/), 'INT', jer)
    call cdf_write(ncid, 'version', version, jer)
    call cdf_write(ncid, 'counter', this % counter, jer)
    call cdf_write(ncid, 'ndims', this % ndims, jer)
    call cdf_write(ncid, 'sizes', this % sizes, jer)
    call cdf_write(ncid, 'start', this % start, jer)
    call cdf_close(ncid, jer) 
    if(jer /= 0) ier = 4
  end subroutine indexer_save

  subroutine indexer_load(this, filename, ier)

    ! Load state from netCDF file 'filename'

    use ezcdf
    implicit none
    type(indexer_obj) :: this
    character(*), intent(in) :: filename
    integer, intent(out) :: ier

    integer ncid, j, jer
    ier = 0
    call cdf_open(ncid, filename, 'r', jer)
    call cdf_read(ncid, 'counter', this % counter, jer)
    call cdf_read(ncid, 'ndims', this % ndims, jer)
    allocate(this % sizes(this % ndims))
    allocate(this % start(this % ndims))
    call cdf_read(ncid, 'sizes', this % sizes, jer)
    call cdf_read(ncid, 'start', this % start, jer)
    call cdf_close(ncid, jer)
    if(jer /= 0) ier = 5
    this % ntot = 1
    do j = 1, this % ndims
       this % ntot = this % ntot * this % sizes(j)
    enddo
  end subroutine indexer_load

  subroutine indexer_error(this, nunit, ier)
    
    ! Print error message

    implicit none
    type(indexer_obj) :: this
    integer, intent(in) :: nunit ! output channel number
    integer, intent(in) :: ier

    character(9), parameter :: header = 'Indexer::'

    select case(ier)
       case(1)
          write(nunit, *) header//'ERROR while allocating'
       case(2)
          write(nunit, *) header//'ERROR while deallocating'
       case(3)
          write(nunit, '(a,i6)') &
               & header//'WARNING counter exceeded declared size ', this % ntot
       case(4)
          write(nunit, *) header//'ERROR while saving'
       case(5)
          write(nunit, *) header//'ERROR while loading'
       case(6)
          write(nunit, *) header//'ERROR occurred in test unit'
       case default
    end select    
  end subroutine indexer_error

  subroutine indexer_test(this, ier)

    ! Test unit

    implicit none
    type(indexer_obj) :: this
    integer, intent(out) :: ier

    integer, allocatable :: sizes(:), start(:), indices(:)
    integer jer, ndims, Js(3), Ls(3), j
    ier = 0

    print *,'testing indexer ', trim(version)
    ! First index represents (x, y, z) field component
    ! Second 3 indices are the Fourier modes which run from -J ... +J
    ! Third 3 indices are spatial indices, running from 0...L

    ndims = 1 + 3 + 3
    allocate(sizes(ndims), start(ndims), indices(ndims))
    sizes(1) = 3 
    start(1) = 1
    Js = (/1,2,3/) ! Fourier
    sizes(2:4) = 2*Js + 1
    start(2:4) = -Js
    Ls = (/2,3,1/) ! spatial 
    sizes(5:7) = Ls+1
    start(5:7) = 0
    call indexer_init(this, sizes, start, jer)
    call indexer_error(this, 6, jer)
    do j = 1, this % ntot
       call indexer_next(this, jer)
       call indexer_error(this, 6, jer)
       call indexer_get(this, indices, jer)
       print *,'Flat array index=',this % counter, &
            & ' Max size=', this  % ntot, &
            & ' Sub-indices=', indices
       call indexer_error(this, 6, jer)       
    enddo
    call indexer_save(this, 'indexer_test.nc', jer)
    call indexer_error(this, 6, jer)
    call indexer_free(this, jer)
    call indexer_error(this, 6, jer)
    call indexer_load(this, 'indexer_test.nc', jer)
    call indexer_error(this, 6, jer)
    call indexer_save(this, 'indexer_test2.nc', jer)
    call indexer_error(this, 6, jer)
    if(jer /= 0) ier = 6
    
    deallocate(sizes, start, indices)
  end subroutine indexer_test  

end module indexer

#!/usr/bin/env sh

cvs -d pletzer@taurus.pppl.gov:/u/pletzer/cvsroot co project/supralu 
cp project/supralu/{d,z}supralu_type.h .
cp project/supralu/{d,z}supralu_meth.c .
cp project/supralu/supralu_mod.f90 .

rm -rf project
